/*****************************************************************
 *
 * Copyright (C) 2009-2010 EZTech Tecnologia e Automao Ltda. 
 * All rights reserved.
 *
 * Created 01/06/2005
 * 
 * File: EZClient.h 
 * Desc: EZClient.DLL API definitions header file  
 *
 * Visual SourceSafe details 
 * =========================
 *
 * $Header: /EZController.root/EZController/EZClientDLL/EZClient.h 1     17/04/07 13:55 Kelvin Ussher $
 * $History: EZClient.h $
 * 
 * *****************  Version 1  *****************
 * User: Kelvin Ussher Date: 17/04/07   Time: 13:55
 * Created in $/EZController.root/EZController/EZClientDLL
 * 
 * 
 ******************************************************************/

#pragma once

#if defined( _LINUX_ ) || defined( _EZCLIENT_LIB ) 
#define EZ_DLL_CALL extern "C" long 
#define EZ_DLL_BSTR extern "C" BSTR
#else 
#define EZ_DLL_CALL extern "C" __declspec(dllexport) long __stdcall
#define EZ_DLL_BSTR extern "C" __declspec(dllexport) BSTR __stdcall
#endif 

#if defined( _LINUX_ )

typedef time_t				DATE ;
typedef unsigned char		BYTE ;
typedef long long 			__int64 ;
typedef unsigned long long  __uint64 ;
typedef wchar_t*			BSTR ;
typedef wchar_t*			PBSTR ;
typedef wchar_t				WCHAR ;
typedef short				SHORT ;
typedef unsigned short		USHORT ;
typedef long				LONG ;
typedef unsigned long       ULONG ;
typedef unsigned long       LPARAM ;
typedef unsigned long		DWORD ;
typedef int					SOCKET ;
typedef void*				HANDLE ;
typedef HANDLE				HWND ;
typedef HANDLE				HMODULE ;
typedef HANDLE				HINSTANCE ;
typedef struct sockaddr		SOCKADDR ;
typedef void*				PVOID ;
#define INVALID_HANDLE_VALUE		((HANDLE)(-1))
#define INVALID_SOCKET  (SOCKET)(~0)
#define SOCKET_ERROR            (-1)
#define Sleep( s )			usleep( ( s ) * 1000 ) 
#define FALSE   0
#define TRUE    1
#else 
typedef BSTR*			PBSTR ;


#endif 

EZ_DLL_CALL DllVersion( PBSTR pName ) ;
EZ_DLL_CALL ServerVersion( PBSTR pName ) ;
EZ_DLL_CALL ClientLogon( long ClientID , short ClientType , HANDLE Event , HWND hWnd, unsigned int wMsg) ;
EZ_DLL_CALL ClientLogonEx( long ClientID , short ClientType , BSTR ServerName , unsigned short CallPortNo , unsigned short EventsPortNo , long CallTimeout, HANDLE Event , HWND hWnd, unsigned int wMsg) ;
EZ_DLL_CALL ClientLogoff() ;
EZ_DLL_CALL ClientStatus( short* pPumpsReserved , short* pdeliveriesLocked ) ;
EZ_DLL_CALL GetLicenseType( short* pLicenseType ) ;
EZ_DLL_CALL FireClientEvent( long EventID , BSTR EventStr ) ;
EZ_DLL_CALL TestConnection() ;
EZ_DLL_CALL ProcessEvents() ;
EZ_DLL_CALL GetEventsCount( long* pCount ) ;
EZ_DLL_CALL GetNextEventType( short* pType ) ;
EZ_DLL_CALL DiscardNextEvent() ;
EZ_DLL_CALL GetNextPumpEvent( long* pPumpID, short* pPumpNumber, short* pState, short* pReservedFor, long* pReservedBy, long* pHoseID ,
							   short* pHoseNumber, long* pGradeID, PBSTR pGradeName , PBSTR pShortGradeName, short* pPriceLevel , double* pPrice, double* pVolume, 
							   double* pValue, short* pStackSize ) ;
EZ_DLL_CALL GetNextDeliveryEvent( long* pDeliveryID , long* pPumpID, short* pPumpNumber, long* pHoseID, short* pHoseNumber , 
								long* pGradeID, PBSTR pGradeName ,PBSTR pShortGradeName, short* pPriceLevel, double* pPrice, double* pVolume, double* pValue, 
								short* pDeliveryState , short* pDeliveryType, long* pLockedBy, long* pReservedBy, long* pAge , DATE* pCompletedDT , long* pAttendantID ) ;
EZ_DLL_CALL GetNextServerEvent( long* pEventID, PBSTR pEventText ) ;
EZ_DLL_CALL GetNextClientEvent( long* pClientID, long* pEventID, PBSTR pEventText ) ;
EZ_DLL_CALL GetNextDBLogEvent( long* pEventType , long* pDeviceID , DATE* pEventDT , PBSTR pEventText ) ;
EZ_DLL_CALL GetNextDBLogDeliveryEvent( long* pDeliveryID, long* pHoseID, short* pDeliveryState, short* pDeliveryType, double* pVolume, short* pPriceLevel, 
							 double* pPrice, double* pValue, double* pVolume2, long* pReservedBy , long* pAttendantID, DATE* pDeliveryDT ) ;
EZ_DLL_CALL GetNextDBClearDeliveryEvent( long* pDeliveryID, short* pDeliveryType, long* pClearedBY, DATE* pClearedDT, long* pAttendantID ) ;
EZ_DLL_CALL GetNextDBStackDeliveryEvent( long* pDeliveryID ) ;
EZ_DLL_CALL GetNextDBHoseETotalsEvent( long* pHoseID , double* pVolume , double* pValue , double* pVolumeETot , double* pValueETot ) ;
EZ_DLL_CALL GetNextDBTriggerEvent( long* pTableID ,long* pRowID ) ;
EZ_DLL_CALL GetNextDBAttendantLogonEvent( long* pAttendantID ,long* pPumpID ) ;
EZ_DLL_CALL GetNextDBAttendantLogoffEvent( long* pAttendantID ) ;
EZ_DLL_CALL GetNextDBTankStatusEvent( long* pTankID , double* pGaugeVolume , double* pGaugeTCVolume, double* pGaugeUllage, double* pGaugeTemperature , 
							          double* pGaugeLevel , double* pGaugeWaterVolume, double* pGaugeWaterLevel ) ;
EZ_DLL_CALL GetPumpsCount( long* pCount ) ;
EZ_DLL_CALL GetPumpByNumber( long Number , long* pID ) ;
EZ_DLL_CALL GetPumpByName( BSTR Name , long* pID ) ;
EZ_DLL_CALL GetPumpByOrdinal( long Index , long* pID ) ;
EZ_DLL_CALL GetPumpProperties(long ID , long* pNumber, PBSTR pName, short* pPhysicalNumber, short* pSide, short* pAddress, short* pPriceLevel1,
						      short* pPriceLevel2, short* pPriceDspFormat, short* pVolumeDspFormat, short* pValueDspFormat, short* pType,  
						      long* pPortID, long* pAttendantID, short* pAuthMode, short* pStackMode, short* pPrepayAllowed, short* pPreauthAllowed ) ;
EZ_DLL_CALL SetPumpProperties(long ID , long Number, BSTR Name, short PhysicalNumber, short Side, short Address, short PriceLevel1,
						      short PriceLevel2, short PriceDspFormat, short VolumeDspFormat, short ValueDspFormat, short Type, 
						      long PortID, long AttendantID, short AuthMode, short StackMode, short PrepayAllowed, short PreauthAllowed ) ;
EZ_DLL_CALL DeletePump( long ID ) ;
EZ_DLL_CALL GetPumpHosesCount( long ID , long* pCount ) ;
EZ_DLL_CALL GetPumpHoseByNumber( long ID , long Number , long* pHoseID ) ;
EZ_DLL_CALL GetPumpStatus( long ID , short* pState, short* pReservedFor, long* pReservedBy, long* pHoseID, short* pHoseNumber , 
						   long* pGradeID, PBSTR pGradeName ,PBSTR pShortGradeName, short* pPriceLevel , double* pPrice , double* pVolume , double* pValue , 
						   short* pStackSize ) ;

EZ_DLL_CALL GetPumpStatusEx( long ID , long* pPumpNumber, PBSTR pPumpName, long* pPhysicalNumber, short* pState, short* pReservedFor, long* pReservedBy, long* pHoseID, long* pHoseNumber , long* pHosePhysicalNumber , long* pGradeID , 
					   long* pGradeNumber , PBSTR pGradeName, PBSTR pShortGradeName, short* pPriceLevel , double* pPrice , double* pVolume , double* pValue , 
					   short* pStackSize , __int64* pTag , 
					   long* pAttendantID , long* pAttendantNumber , PBSTR pAttendantName, __int64* pAttendantTag ,
					   long* pCardClientID , long* pCardClientNumber , PBSTR pCardClientName, __int64* pCardClientTag ) ;

EZ_DLL_CALL GetPumpDeliveryProperties( long ID , short Index , long* pDeliveryID , short* pType , short* pState, long* pHoseID, 
									   short* pHoseNum, long* pGradeID , PBSTR pGradeName ,PBSTR pShortGradeName, short* pPriceLevel, double* pPrice , double* pVolume , 
									   double* pValue , long* pLockedBy , long* pReservedBy , long* pAge , DATE* pCompletedDT , long* pAttendantID  ) ;
EZ_DLL_CALL GetPumpDeliveryPropertiesEx( long ID , short Index , long* pDeliveryID , short* pType , short* pState, long* pHoseID, short* pHoseNum, long* pGradeID, PBSTR pGradeName, PBSTR pShortGradeName , 
								        short* pPriceLevel, double* pPrice , double* pVolume , double* pValue , long* pLockedBy , 
									    long* pReservedBy , long* pAge , DATE* pCompletedDT , long* pAttendantID , double* pVolumeETot , double* pVolume2ETot , double* pValueETot , __int64* pTag ) ;
EZ_DLL_CALL GetPumpDeliveryPropertiesEx2( long ID , short Index , long* pDeliveryID , short* pType , short* pState, long* pHoseID, short* pHoseNum, long* pGradeID, PBSTR pGradeName, PBSTR pShortGradeName , 
								        short* pPriceLevel, double* pPrice , double* pVolume , double* pValue , long* pLockedBy , 
									    long* pReservedBy , long* pAge , DATE* pCompletedDT , long* pAttendantID , 
										double* pOldVolumeETot , double* pOldVolume2ETot , double* pOldValueETot , 
										double* pNewVolumeETot , double* pNewVolume2ETot , double* pNewValueETot , 
										__int64* pTag , long * pDuration ) ;
EZ_DLL_CALL GetPumpDeliveryPropertiesEx3( long ID , short Index , long* pDeliveryID , short* pType , short* pState, long* pHoseID, short* pHoseNum, long* pGradeID, PBSTR pGradeName, PBSTR pShortGradeName , 
								        short* pPriceLevel, double* pPrice , double* pVolume , double* pValue , long* pLockedBy , 
									    long* pReservedBy , long* pAge , DATE* pCompletedDT , long* pAttendantID , 
										double* pOldVolumeETot , double* pOldVolume2ETot , double* pOldValueETot , 
										double* pNewVolumeETot , double* pNewVolume2ETot , double* pNewValueETot , 
										__int64* pTag , long * pDuration , long* pCardClientID ) ;
EZ_DLL_CALL PrepayReserve( long ID ) ;
EZ_DLL_CALL PrepayCancel( long ID  ) ;
EZ_DLL_CALL PrepayAuthorise( long ID , short LimitType , double Value , short Hose , short PriceLevel ) ;
EZ_DLL_CALL PreauthReserve( long ID ) ;
EZ_DLL_CALL PreauthCancel( long ID ) ;
EZ_DLL_CALL PreauthAuthorise( long ID , short LimitType , double Value , short Hose , short PriceLevel ) ;
EZ_DLL_CALL LoadPreset( long ID , short LimitType , double Value , short Hose , short PriceLevel ) ;
EZ_DLL_CALL LoadPresetWithPrice( long ID , short LimitType , double Value , short Hose , short PriceLevel , double Price ) ;
EZ_DLL_CALL TagAuthorise( long ID , __int64 Tag , short LimitType , double Value , short Hose , short PriceLevel ) ;
EZ_DLL_CALL AttendantAuthorise( long ID , long AttendantID ) ;
EZ_DLL_CALL Authorise( long ID ) ;
EZ_DLL_CALL CancelAuthorise( long ID ) ;
EZ_DLL_CALL TempStop( long ID ) ;
EZ_DLL_CALL ReAuthorise( long ID ) ;
EZ_DLL_CALL TerminateDelivery( long ID ) ;
EZ_DLL_CALL StackCurrentDelivery( long ID ) ;
EZ_DLL_CALL GetDensity( long ID , double* pDensity) ;
EZ_DLL_CALL EnablePump( long ID ) ;
EZ_DLL_CALL DisablePump( long ID ) ;
EZ_DLL_CALL GetHosesCount( long* pCount ) ;
EZ_DLL_CALL GetHoseByOrdinal( long Index , long* pID ) ;
EZ_DLL_CALL GetHoseProperties(long ID , long* pNumber, long* pPumpID ,long* pTankID , long* pPhysicalNumber, 
		                      double* pMtrTheoValue , double* pMtrTheoVolume ,double* pMtrElecValue ,
				              double* pMtrElecVolume ) ;
EZ_DLL_CALL SetHoseProperties(long ID , long Number,long PumpID, long TankID , long PhysicalNumber, 
		                      double MtrTheoValue , double MtrTheoVolume ,double MtrElecValue ,
				              double MtrElecVolume ) ;
EZ_DLL_CALL GetHoseSummary(	long ID , long* pNumber, long* pPhysicalNumber,
							long* pPumpID, long* pPumpNumber, PBSTR pPumpName,
							long* pTankID, long* pTankNumber, PBSTR pTankName,
							long* pGradeID , long* pGradeNumber, PBSTR pGradeName, PBSTR pGradeShortName, PBSTR pGradeCode,
		                    double* pMtrTheoValue , double* pMtrTheoVolume ,double* pMtrElecValue , double* pMtrElecVolume ) ;

EZ_DLL_CALL GetHoseSummaryEx(	long ID , long* pNumber, long* pPhysicalNumber,
							long* pPumpID, long* pPumpNumber, PBSTR pPumpName,
							long* pTankID, long* pTankNumber, PBSTR pTankName,
							long* pGradeID , long* pGradeNumber, PBSTR pGradeName, PBSTR pGradeShortName, PBSTR pGradeCode,
		                    double* pMtrTheoValue , double* pMtrTheoVolume ,double* pMtrElecValue , double* pMtrElecVolume ,
							double* pPrice1 , double* pPrice2 , short* pEnabled) ;

EZ_DLL_CALL DeleteHose( long ID ) ;
EZ_DLL_CALL GetDeliveriesCount( long* pCount ) ;
EZ_DLL_CALL GetDeliveryByOrdinal( long Index , long* pID ) ;
EZ_DLL_CALL GetAllDeliveriesCount( long* pCount )  ;
EZ_DLL_CALL GetAllDeliveryByOrdinal( long Index , long* pID ) ;

EZ_DLL_CALL AckDeliveryDBLog( long ID ) ; 
EZ_DLL_CALL GetDeliveryIDByOrdinalNotLogged( long Ordinal , long* pID ) ;
EZ_DLL_CALL GetDeliveriesCountNotLogged( long* pCount ) ;
EZ_DLL_CALL AckDeliveryVolLog( long ID ) ; 
EZ_DLL_CALL GetDeliveryIDByOrdinalNotVolLogged( long Ordinal , long* pID ) ;
EZ_DLL_CALL GetDeliveriesCountNotVolLogged( long* pCount ) ;

EZ_DLL_CALL GetDeliveryProperties( long ID , long* pHoseID ,short* pState ,short* pType ,double* pVolume ,
								   short* pPriceLevel ,double* pPrice ,double* pValue ,double* pVolume2 , 
								   DATE* pCompletedDT ,long* pLockedBy , long* pReservedBy , long* pAttendantID , long* pAge ) ;
EZ_DLL_CALL GetDeliveryPropertiesEx( long ID , long* pHoseID ,short* pState ,short* pType ,double* pVolume ,short* pPriceLevel ,
		                           double* pPrice ,double* pValue ,double* pVolume2 , DATE* pCompletedDT ,long* pLockedBy, long* pReservedBy , long* pAttendantID , long* pAge , 
								   DATE* pClearedDT ,double* pVolumeETot , double* pVolume2ETot , double* pValueETot , __int64* pTag ) ;
EZ_DLL_CALL GetDeliveryPropertiesEx2( long ID , long* pHoseID ,short* pState ,short* pType ,double* pVolume ,short* pPriceLevel ,
		                           double* pPrice ,double* pValue ,double* pVolume2 , DATE* pCompletedDT ,long* pLockedBy, long* pReservedBy , 
								   long* pAttendantID , long* pAge , DATE* pClearedDT ,
								   double* pOldVolumeETot , double* pOldVolume2ETot , double* pOldValueETot , 
								   double* pNewVolumeETot , double* pNewVolume2ETot , double* pNewValueETot , 
								   __int64* pTag , long * pDuration ) ;
EZ_DLL_CALL GetDeliveryPropertiesEx3( long ID , long* pHoseID ,short* pState ,short* pType ,double* pVolume ,short* pPriceLevel ,
		                           double* pPrice ,double* pValue ,double* pVolume2 , DATE* pCompletedDT ,long* pLockedBy, long* pReservedBy , 
								   long* pAttendantID , long* pAge , DATE* pClearedDT ,
								   double* pOldVolumeETot , double* pOldVolume2ETot , double* pOldValueETot , 
								   double* pNewVolumeETot , double* pNewVolume2ETot , double* pNewValueETot , 
								   __int64* pTag , long * pDuration , long* pCardClientID ) ;

EZ_DLL_CALL SetDeliveryProperties( long ID , long HoseID ,short State ,short Type ,double Volume ,short PriceLevel ,
								   double Price ,double Value ,double Volume2, DATE CompletedDT ,long LockedBy, long ReservedBy , 
								   long AttendantID , long Age ) ;
EZ_DLL_CALL SetDeliveryPropertiesEx( long ID , long HoseID ,short State ,short Type ,double Volume ,short PriceLevel ,
								   double Price ,double Value ,double Volume2 , DATE CompletedDT ,long LockedBy, 
								   long ReservedBy , long AttendantID , long Age , DATE ClearedDT , double VolumeETot , double Volume2ETot , double ValueETot , __int64 Tag ) ;
EZ_DLL_CALL SetDeliveryPropertiesEx2( long ID , long HoseID ,short State ,short Type ,double Volume ,short PriceLevel ,
								   double Price ,double Value ,double Volume2 , DATE CompletedDT ,long LockedBy, 
								   long ReservedBy , long AttendantID , long Age , DATE ClearedDT , 
								   double OldVolumeETot , double OldVolume2ETot , double OldValueETot , 
								   double NewVolumeETot , double NewVolume2ETot , double NewValueETot , 
								   __int64 Tag , long Duration ) ;


EZ_DLL_CALL SetDeliveryPropertiesEx3( long ID , long HoseID ,short State ,short Type ,double Volume ,short PriceLevel ,
								   double Price ,double Value ,double Volume2 , DATE CompletedDT ,long LockedBy, 
								   long ReservedBy , long AttendantID , long Age , DATE ClearedDT , 
								   double OldVolumeETot , double OldVolume2ETot , double OldValueETot , 
								   double NewVolumeETot , double NewVolume2ETot , double NewValueETot , 
								   __int64 Tag , long Duration , long CardClientID ) ; 

EZ_DLL_CALL GetDeliverySummary( long ID , long* pHoseID ,long* pHoseNumber, long* pHosePhysicalNumber,
	  							long* pPumpID, long* pPumpNumber, PBSTR  pPumpName,
								long* pTankID, long* pTankNumber, PBSTR  pTankName,
								long* pGradeID , long* pGradeNumber, PBSTR  pGradeName, PBSTR  pGradeShortName, PBSTR  pGradeCode,
							    short* pState ,short* pType ,double* pVolume ,short* pPriceLevel ,
								double* pPrice ,double* pValue ,double* pVolume2 , DATE* pCompletedDT ,long* pLockedBy, 
								long* pReservedBy , long* pAttendantID , long* pAge ,DATE* pClearedDT ,
								double* pVolumeETot , double* pVolume2ETot , double* pValueETot , __int64* pTag) ;
EZ_DLL_CALL GetDeliverySummaryEx( long ID , long* pHoseID ,long* pHoseNumber, long* pHosePhysicalNumber,
	  							long* pPumpID, long* pPumpNumber, PBSTR  pPumpName,
								long* pTankID, long* pTankNumber, PBSTR  pTankName,
								long* pGradeID , long* pGradeNumber, PBSTR  pGradeName, PBSTR  pGradeShortName, PBSTR  pGradeCode,
							    short* pState ,short* pType ,double* pVolume ,short* pPriceLevel ,
		                        double* pPrice ,double* pValue ,double* pVolume2 , DATE* pCompletedDT ,long* pLockedBy, 
								long* pReservedBy , long* pAttendantID , long* pAge ,DATE* pClearedDT ,
								double* pOldVolumeETot , double* pOldVolume2ETot , double* pOldValueETot , 
								double* pNewVolumeETot , double* pNewVolume2ETot , double* pNewValueETot , 
								__int64* pTag , long * pDuration ) ;
EZ_DLL_CALL GetDeliverySummaryEx2( long ID , long* pHoseID ,long* pHoseNumber, long* pHosePhysicalNumber,
	  							long* pPumpID, long* pPumpNumber, PBSTR  pPumpName,
								long* pTankID, long* pTankNumber, PBSTR  pTankName,
								long* pGradeID , long* pGradeNumber, PBSTR  pGradeName, PBSTR  pGradeShortName, PBSTR  pGradeCode,
							    short* pState ,short* pType ,double* pVolume ,short* pPriceLevel ,
		                        double* pPrice ,double* pValue ,double* pVolume2 , DATE* pCompletedDT ,long* pLockedBy, 
								long* pReservedBy , long* pAttendantID , long* pAge ,DATE* pClearedDT ,
								double* pOldVolumeETot , double* pOldVolume2ETot , double* pOldValueETot , 
								double* pNewVolumeETot , double* pNewVolume2ETot , double* pNewValueETot , 
								__int64* pTag , long * pDuration , long* pAttendantNumber , PBSTR pAttendantName, __int64* pAttendantTag ,
								long* pCardClientID , long* pCardClientNumber , PBSTR pCardClientName, __int64* pCardClientTag ) ;
EZ_DLL_CALL LockDelivery( long ID ) ;
EZ_DLL_CALL UnlockDelivery( long ID ) ;
EZ_DLL_CALL ClearDelivery( long ID , short Type ) ;
EZ_DLL_CALL LockAndClearDelivery( long ID , short Type ) ;
EZ_DLL_CALL GetDuration( long ID , long* pDuration ) ;
EZ_DLL_CALL GetGradesCount( long* pCount ) ;
EZ_DLL_CALL GetGradeByNumber( long Number , long* pID ) ;
EZ_DLL_CALL GetGradeByName( BSTR Name , long* pID ) ;
EZ_DLL_CALL GetGradeByOrdinal( long Index , long* pID ) ;
EZ_DLL_CALL GetGradeProperties(long ID , long* pNumber, PBSTR pName , PBSTR pShortName , PBSTR pCode ) ;
EZ_DLL_CALL SetGradeProperties(long ID , long Number, BSTR Name , BSTR ShortName , BSTR Code  ) ;
EZ_DLL_CALL DeleteGrade( long ID ) ;
EZ_DLL_CALL SetGradePrice( long ID , short Level , double Price ) ;
EZ_DLL_CALL GetGradePrice( long ID , short Level , double* pPrice ) ;
EZ_DLL_CALL GetTanksCount( long* pCount ) ;
EZ_DLL_CALL GetTankByNumber( long Number , long* pID ) ;
EZ_DLL_CALL GetTankByName( BSTR Name , long* pID ) ;
EZ_DLL_CALL GetTankByOrdinal( long Index , long* pID ) ;
EZ_DLL_CALL GetTankProperties(long ID , long* pNumber, PBSTR pName , long* pGradeID , short* pType , double* pCapacity , double* pDiameter , 
							  double* pTheoVolume , double* pGaugeVolume , double* pGaugeTCVolume, double* pGaugeUllage, double* pGaugeTemperature , 
							  double* pGaugeLevel , double* pGaugeWaterVolume, double* pGaugeWaterLevel, long* pGaugeID, short* pProbeNo ) ;
EZ_DLL_CALL SetTankProperties(long ID , long Number, BSTR Name , long GradeID , short Type , double Capacity , double Diameter , double TheoVolume , 
		                      double GaugeVolume , double GaugeTCVolume ,double GaugeUllage ,double GaugeTemperature , double GaugeLevel , 
							  double GaugeWaterVolume, double GaugeWaterLevel, long GaugeID , short ProbeNo ) ;
EZ_DLL_CALL GetTankSummary(long ID , long* pNumber, PBSTR pName , long* pGradeID , 
						   long* pGradeNumber, PBSTR pGradeName, PBSTR pGradeShortName, PBSTR pGradeCode, 
						   short* pType , double* pCapacity , double* pDiameter , 
						   double* pTheoVolume , double* pGaugeVolume , double* pGaugeTCVolume, double* pGaugeUllage, double* pGaugeTemperature , 
						   double* pGaugeLevel , double* pGaugeWaterVolume, double* pGaugeWaterLevel, long* pGaugeID, short* pProbeNo ) ;
EZ_DLL_CALL TankDrop( long ID , double Volume , DATE DropDT , BSTR Terminal , BSTR DocumentType , DATE DocumentDT  , BSTR DocumentFolio , double PEMEXVolume ) ;
EZ_DLL_CALL DeleteTank( long ID ) ;
EZ_DLL_CALL GetPortsCount( long* pCount ) ;
EZ_DLL_CALL GetPortByNumber( long Number , long* pID ) ;
EZ_DLL_CALL GetPortByName( BSTR Name , long* pID ) ;
EZ_DLL_CALL GetPortByOrdinal( long Index , long* pID ) ;
EZ_DLL_CALL GetPortProperties(long ID , long* pNumber, PBSTR pName , long* pProtocolID , short* pDeviceType , PBSTR pSerialNo ) ;
EZ_DLL_CALL SetPortProperties(long ID , long Number, BSTR Name, long ProtocolID , short DeviceType , BSTR SerialNo ) ;
EZ_DLL_CALL GetAttendantsCount( long* pCount ) ;
EZ_DLL_CALL GetAttendantByNumber( long Number , long* pID ) ;
EZ_DLL_CALL GetAttendantByName( BSTR Name , long* pID ) ;
EZ_DLL_CALL GetAttendantByOrdinal( long Index , long* pID ) ;
EZ_DLL_CALL GetAttendantProperties(long ID , long* pNumber, PBSTR pName , PBSTR pShortName , PBSTR pPassword , PBSTR pTag ) ; 
EZ_DLL_CALL SetAttendantProperties(long ID , long Number, BSTR Name , BSTR ShortName , BSTR Password , BSTR Tag ) ; 
EZ_DLL_CALL GetAttendantPropertiesEx(long ID , long* pNumber, PBSTR pName , PBSTR pShortName , PBSTR pPassword , PBSTR pTag , 
									 short* pShiftAStart , short* pShiftAEnd , short* pShiftBStart , short* pShiftBEnd , short* pEnabled )  ;
EZ_DLL_CALL SetAttendantPropertiesEx(long ID , long Number, BSTR Name , BSTR ShortName , BSTR Password , BSTR Tag,
									 short ShiftAStart , short ShiftAEnd , short ShiftBStart , short ShiftBEnd , short Enabled )  ;
EZ_DLL_CALL DeleteAttendant( long ID ) ;
EZ_DLL_CALL AttendantLogon( long ID , long PumpID ) ;
EZ_DLL_CALL AttendantLogoff( long ID ) ;

EZ_DLL_CALL GetCardReadsCount( long* pCount ) ;
EZ_DLL_CALL GetCardReadByNumber( long Number , long* pID ) ;
EZ_DLL_CALL GetCardReadByName( BSTR Name , long* pID ) ;
EZ_DLL_CALL GetCardReadByOrdinal( long Index , long* pID ) ;
EZ_DLL_CALL GetCardReadProperties(long ID , long* pNumber, PBSTR pName , long* pPumpID , short* pType , long* pParentID , __int64* pTag , DATE* pTimeStamp )  ;
EZ_DLL_CALL SetCardReadProperties(long ID , long Number, BSTR Name , long PumpID , short Type , long ParentID , __int64 Tag , DATE TimeStamp)  ;
EZ_DLL_CALL DeleteCardRead( long ID ) ;
EZ_DLL_CALL GetCardClientsCount( long* pCount ) ;
EZ_DLL_CALL GetCardClientByNumber( long Number , long* pID ) ;
EZ_DLL_CALL GetCardClientByName( BSTR Name , long* pID ) ;
EZ_DLL_CALL GetCardClientByOrdinal( long Index , long* pID ) ;
EZ_DLL_CALL GetCardClientProperties(long ID , long* pNumber, PBSTR pName , PBSTR pTag , short* pEnabled )  ;
EZ_DLL_CALL SetCardClientProperties(long ID , long Number, BSTR Name , BSTR Tag , short Enabled )  ;
EZ_DLL_CALL DeleteCardClient( long ID ) ;

EZ_DLL_CALL AllStop() ;
EZ_DLL_CALL AllAuthorise() ;
EZ_DLL_CALL AllReAuthorise() ;
EZ_DLL_CALL AllStopIfIdle() ;
EZ_DLL_CALL ReadAllTanks() ;
EZ_DLL_CALL GetAllPumpStatuses( PBSTR pStates , PBSTR pCurrentHoses , PBSTR pDeliveriesCount ) ; 
EZ_DLL_CALL GetIniValue( BSTR Section , BSTR Key , PBSTR pValue ) ; 
EZ_DLL_CALL SetIniValue( BSTR Section , BSTR Key , BSTR Value ) ; 
EZ_DLL_CALL SetNextDeliveryID( long ID ) ;
EZ_DLL_CALL RemovePort( long ID ) ;
EZ_DLL_CALL LicenseStatus() ;
EZ_DLL_CALL CheckSocketClosed( LPARAM lParam ) ;

EZ_DLL_BSTR ResultString( long Res ) ;
EZ_DLL_BSTR PumpStateString( short State ) ;
EZ_DLL_BSTR DeliveryStateString( short State ) ;
EZ_DLL_BSTR DeliveryTypeString( short Type ) ;
EZ_DLL_BSTR ReserveTypeString( short Type ) ;

// *** new APIS
EZ_DLL_CALL GetNextPumpEventEx( long* pPumpID, short* pPumpNumber, short* pState, short* pReservedFor, long* pReservedBy, long* pHoseID ,
							    short* pHoseNumber,long* pGradeID, PBSTR pGradeName , PBSTR pShortGradeName, short* pPriceLevel , double* pPrice, double* pVolume, 
							    double* pValue, short* pStackSize , PBSTR pPumpName , short* pPhysicalNumber , short* pSide , short* pAddress, 
								short* pPriceLevel1 , short* pPriceLevel2 , short* pType , long* pPortID , short* pAuthMode , short* pStackMode ,  short* pPrepayAllowed, 
								short* pPreauthAllowed ,  short* pPriceFormat , short* pValueFormat , short* pVolumeFormat  ) ;

EZ_DLL_CALL GetNextPumpEventEx2( long* pPumpID, long* pPumpNumber, short* pState, short* pReservedFor, long* pReservedBy, long* pHoseID ,
							    long* pHoseNumber,long* pHosePhysicalNumber,long* pGradeID,long* pGradeNumber, PBSTR pGradeName , PBSTR pShortGradeName, short* pPriceLevel , double* pPrice, double* pVolume, 
							    double* pValue, short* pStackSize , PBSTR pPumpName , long* pPhysicalNumber , short* pSide , short* pAddress, 
								short* pPriceLevel1 , short* pPriceLevel2 , short* pType , long* pPortID , short* pAuthMode , short* pStackMode ,  short* pPrepayAllowed, 
								short* pPreauthAllowed ,  short* pPriceFormat , short* pValueFormat , short* pVolumeFormat , __int64* pTag , 
							    long* pAttendantID , long* pAttendantNumber , PBSTR pAttendantName, __int64* pAttendantTag ,
							    long* pCardClientID , long* pCardClientNumber , PBSTR pCardClientName, __int64* pCardClientTag  ) ;

EZ_DLL_CALL GetNextDeliveryEventEx( long* pDeliveryID , long* pPumpID, short* pPumpNumber, long* pHoseID, short* pHoseNumber , 
								    long* pGradeID, PBSTR pGradeName , PBSTR pShortGradeName, short* pPriceLevel, double* pPrice, 
									double* pVolume, double* pValue, short* pDeliveryState , 
								    short* pDeliveryType, long* pLockedBy, long* pReservedBy, long* pAge , DATE* pCompletedDT , 
									long* pAttendantID, double* pVolumeETot , double* pVolume2ETot , double* pValueETot , __int64* pTag) ;
EZ_DLL_CALL  GetNextDeliveryEventEx2( long* pDeliveryID , long* pPumpID, short* pPumpNumber, long* pHoseID, short* pHoseNumber , 
								     long* pGradeID, PBSTR pGradeName , PBSTR pShortGradeName, short* pPriceLevel, double* pPrice, 
									 double* pVolume, double* pValue, short* pDeliveryState , 
								     short* pDeliveryType, long* pLockedBy, long* pReservedBy, long* pAge , DATE* pCompletedDT , 
									 long* pAttendantID, 
									 double* pOldVolumeETot , double* pOldVolume2ETot , double* pOldValueETot , 
									 double* pNewVolumeETot , double* pNewVolume2ETot , double* pNewValueETot , 
									 __int64* pTag , long* pDuration ) ;
EZ_DLL_CALL  GetNextDeliveryEventEx3( long* pDeliveryID, long* pHoseID ,long* pHoseNumber, long* pHosePhysicalNumber,
	  									long* pPumpID, long* pPumpNumber, PBSTR pPumpName,
										long* pTankID, long* pTankNumber, PBSTR pTankName,
										long* pGradeID , long* pGradeNumber, PBSTR pGradeName, PBSTR pGradeShortName, PBSTR pGradeCode,
										short* pState ,short* pType ,double* pVolume ,short* pPriceLevel ,
										double* pPrice ,double* pValue ,double* pVolume2 , DATE* pCompletedDT , long* pLockedBy, 
										long* pReservedBy , long* pAttendantID , long* pAge , DATE* pClearedDT , 
										double* pOldVolumeETot, double* pOldVolume2ETot, double* pOldValueETot , 
										double* pNewVolumeETot, double* pNewVolume2ETot, double* pNewValueETot , 
										__int64* pTag , long* pDuration , long* pAttendantNumber , PBSTR AttendantName, __int64* pAttendantTag ,
										long* pCardClientID , long* pCardClientNumber , PBSTR CardClientName, __int64* pCardClientTag ) ; 
EZ_DLL_CALL GetNextCardReadEvent( long* pCardReadID , long* pNumber, PBSTR pName , long* pPumpID , short* pType , long* pParentID , __int64* pTag , DATE* pTimeStamp) ;
EZ_DLL_CALL GetNextDBHoseETotalsEventEx( long* pHoseID , double* pVolume , double* pValue , double* pVolumeETot , double* pValueETot , 
										 long* pHoseNumber , long* pHosePhysicalNumber , long* pPumpID , long* pPumpNumber , PBSTR pPumpName , 
										 long* pTankID , long* pTankNumber , PBSTR pTankName , long* pGradeID , PBSTR pGradeName ) ;
EZ_DLL_CALL GetNextDBTankStatusEventEx( long* pTankID , double* pGaugeVolume , double* pGaugeTCVolume, double* pGaugeUllage, 
									    double* pGaugeTemperature , double* pGaugeLevel , double* pGaugeWaterVolume, double* pGaugeWaterLevel , 
									    long* pTankNumber , PBSTR pTankName , long* pGradeID , PBSTR pGradeName , short*pType  , 
										double* pCapacity , double* pDiameter , long* pGaugeID , short* pProbeNo) ;
EZ_DLL_CALL GetNextSerialPortEvent( long* pPortID , long* pZBID , short* pSlot , short* pResult , PBSTR pRxMsg ) ; 
EZ_DLL_CALL GetNextZBEvent( long* pPortID , long* pZBID , __int64* pZBAddress, short* pResult , short* pMsgType , PBSTR pRxMsg ) ; 
EZ_DLL_CALL GetNextUVEEvent( long* pPumpID , long* pPumpNumber , long* pHoseID , long* pHoseNumber , PBSTR pUVE ) ;
EZ_DLL_CALL GetZigBeeCount( long* pCount ) ;
EZ_DLL_CALL GetZigBeeByNumber( long Number , long* pID ) ;
EZ_DLL_CALL GetZigBeeByName( BSTR Name , long* pID ) ;
EZ_DLL_CALL GetZigBeeByOrdinal( long Index , long* pID ) ;
EZ_DLL_CALL GetZigBeeProperties(long ID , long* pNumber, PBSTR pName , short* pDeviceType , PBSTR pSerialNumber , PBSTR pNodeIdentifier , long* pPortID ) ;
EZ_DLL_CALL SetZigBeeProperties(long ID , long Number, BSTR Name , short DeviceType , BSTR SerialNumber , BSTR NodeIdentifier , long PortID ) ;
EZ_DLL_CALL DeleteZigBee( long ID ) ;
EZ_DLL_CALL GetHosePropertiesEx(long ID , long* pNumber, long* pPumpID ,long* pTankID , long* pPhysicalNumber, 
		                      double* pMtrTheoValue , double* pMtrTheoVolume ,double* pMtrElecValue ,
				              double* pMtrElecVolume , short* pUVEAntenna ) ;
EZ_DLL_CALL SetHosePropertiesEx(long ID , long Number,long PumpID, long TankID , long PhysicalNumber, 
		                      double MtrTheoValue , double MtrTheoVolume ,double MtrElecValue ,
				              double MtrElecVolume , short UVEAntenna );
EZ_DLL_CALL GetHosePropertiesEx2(long ID , long* pNumber, long* pPumpID ,long* pTankID , long* pPhysicalNumber, 
		                      double* pMtrTheoValue , double* pMtrTheoVolume ,double* pMtrElecValue ,
				              double* pMtrElecVolume , short* pUVEAntenna , double* pPrice1 , double* pPrice2 , short* pEnabled ) ;
EZ_DLL_CALL SetHosePropertiesEx2(long ID , long Number,long PumpID, long TankID , long PhysicalNumber, 
		                      double MtrTheoValue , double MtrTheoVolume ,double MtrElecValue ,
				              double MtrElecVolume , short UVEAntenna , double Price1 , double Price2 , short Enabled ) ;
EZ_DLL_CALL SetPumpPropertiesEx(long ID , long Number, BSTR Name, short PhysicalNumber, short Side, short Address, short PriceLevel1,
						        short PriceLevel2, short PriceDspFormat, short VolumeDspFormat, short ValueDspFormat, short Type, 
						        long PortID, long AttendantID, short AuthMode, short StackMode, short PrepayAllowed, short PreauthAllowed , 
								long SlotZigBeeID , long MuxSlotZigBeeID , short PriceControl , short HasPreset ) ;
EZ_DLL_CALL GetPumpPropertiesEx(long ID , long* pNumber, PBSTR pName, short* pPhysicalNumber, short* pSide, short* pAddress, short* pPriceLevel1,
						      short* pPriceLevel2, short* pPriceDspFormat, short* pVolumeDspFormat, short* pValueDspFormat, short* pType, 
						      long* pPortID, long* pAttendantID, short* pAuthMode, short* pStackMode, short* pPrepayAllowed, short* pPreauthAllowed ,
							  long* pSlotZigBeeID , long* pMuxSlotZigBeeID , short* pPriceControl , short* pHasPreset) ;
EZ_DLL_CALL CTFReserve( long ID ) ;
EZ_DLL_CALL CTFCancel( long ID ) ;
EZ_DLL_CALL CTFAuthorise( long ID , short LimitType , double Value , double Value2 , short Hose , short PriceLevel , BSTR UVE , short UVEType , short UVETimeout, short IBMPulserTimeout, short StopDelay ) ;
EZ_DLL_CALL GetSerialNo( long ID , PBSTR pSerialNo ) ; 
EZ_DLL_CALL GetDeviceDetails( long ID , long ZBID , PBSTR pSerialNo , PBSTR pBootVersion , PBSTR pFirmwareVersion ) ;
EZ_DLL_CALL ResetDevice( long ID , long ZBID ) ;
EZ_DLL_CALL RequestVersion( long ID , long ZBID ) ;
EZ_DLL_CALL ZBRegisterInterest( long ID , long ZBID ) ; 
EZ_DLL_CALL ZBExceptionRegisterInterest( long ID ) ;
EZ_DLL_CALL ZBHeartBeatRegisterInterest( long ID ) ;
EZ_DLL_CALL SerialPortSend( long ID , long ZBID , short Slot , short Type , BSTR TxMsg ) ;
EZ_DLL_CALL SerialPortConfig( long ID , long ZBID , short Slot , short COMPort , long BPS , short DataBits , short Parity , short StopBits , short ResponseMaxLen , short ResponseTimeout , short ResponseInterCharTimeout ) ;
EZ_DLL_CALL ZBSend( long ID , long ZBID, __int64 ZBAddress, short MsgType , BSTR TxMsg ) ; 
EZ_DLL_CALL UVERegisterInterest( long ID ) ;
EZ_DLL_CALL GetDeviceDetails( long ID , long ZBID , PBSTR pSerialNo , PBSTR pBootVersion , PBSTR pFirmwareVersion ) ;
EZ_DLL_CALL SetZBCoordPan( long ID , __int64 Pan ) ;
EZ_DLL_CALL GetZBCoordPan( long ID ) ;
EZ_DLL_CALL ReadUVE( long ID , long ZBID , short Antenna ) ; 
EZ_DLL_CALL SetHoseETotals( long ID , double Volume , double Value ) ;
EZ_DLL_CALL GetNextZBStatusEvent( long* pPortID , long* pZBID , __int64* pZBAddress, short* pCondition , short* pCount , short* pStrength ) ;
EZ_DLL_CALL GetNextZBPanIDEvent( long* pPortID , __int64* pZBPanID ) ;
EZ_DLL_CALL GetNextZeroDeliveryEvent( long* pPumpID , long* pPumpNumber , long* pHoseID , long* pHoseNumber ) ;
EZ_DLL_CALL SetIOPin( long ID , long ZBID , short Slot , short IOPin , short Value ) ;
EZ_DLL_CALL SetLineMode( long ID , long ZBID , short Mode ) ;
EZ_DLL_CALL SetHosePrices( long ID , short DurationType , short PriceType , double Price1 , double Price2 ) ;
EZ_DLL_CALL GetHosePrices( long ID , short* pDurationType , short* pPriceType , double* pPrice1 , double* pPrice2 ) ;
EZ_DLL_CALL SetPumpDefaultPriceLevel( long ID , short Level ) ;
EZ_DLL_CALL SetDateTime( DATE DateTime ) ;
EZ_DLL_CALL GetNextZBCmdEvent( long* pPortID , long* pZBID , __int64* pZBAddress, PBSTR pRxMsg ) ;
EZ_DLL_CALL GetNextZBRawEvent( long* pPortID , long* pZBID , __int64* pZBAddress, PBSTR pRxMsg ) ;
EZ_DLL_CALL ZBSendRaw( long ID , long ZBID , __int64 ZBAddress , BSTR TxMsg ) ;
EZ_DLL_CALL ZBSendCmd( long ID , long ZBID , __int64 ZBAddress , BSTR TxMsg ) ;
EZ_DLL_CALL ZBCmdRegisterInterest( long ID , long ZBID ) ;
EZ_DLL_CALL ZBRawRegisterInterest( long ID , long ZBID ) ;

// not valid for CE 
EZ_DLL_CALL IsValidMACLicense( BSTR LicenseKey ) ;			



class CEZCLProcess ;

EZ_DLL_CALL ServerVersionMT(CEZCLProcess* pCLProcess ,  PBSTR pName ) ;
EZ_DLL_CALL ClientLogonMT(CEZCLProcess** ppCLProcess ,  long ClientID , short ClientType , HANDLE Event , HWND hWnd, unsigned int wMsg) ;
EZ_DLL_CALL ClientLogonExMT(CEZCLProcess** ppCLProcess ,  long ClientID , short ClientType , BSTR ServerName , unsigned short CallPortNo , unsigned short EventsPortNo , long CallTimeout, HANDLE Event , HWND hWnd, unsigned int wMsg) ;
EZ_DLL_CALL ClientLogoffMT(CEZCLProcess** ppCLProcess ) ;
EZ_DLL_CALL ClientStatusMT(CEZCLProcess* pCLProcess ,  short* pPumpsReserved , short* pdeliveriesLocked ) ;
EZ_DLL_CALL GetLicenseTypeMT(CEZCLProcess* pCLProcess ,  short* pLicenseType ) ;
EZ_DLL_CALL FireClientEventMT(CEZCLProcess* pCLProcess ,  long EventID , BSTR EventStr ) ;
EZ_DLL_CALL TestConnectionMT(CEZCLProcess* pCLProcess ) ;
EZ_DLL_CALL ProcessEventsMT(CEZCLProcess* pCLProcess ) ;
EZ_DLL_CALL GetEventsCountMT(CEZCLProcess* pCLProcess ,  long* pCount ) ;
EZ_DLL_CALL GetNextEventTypeMT(CEZCLProcess* pCLProcess ,  short* pType ) ;
EZ_DLL_CALL DiscardNextEventMT(CEZCLProcess* pCLProcess ) ;
EZ_DLL_CALL GetNextPumpEventMT(CEZCLProcess* pCLProcess ,  long* pPumpID, short* pPumpNumber, short* pState, short* pReservedFor, long* pReservedBy, long* pHoseID ,
							   short* pHoseNumber, long* pGradeID, PBSTR pGradeName , PBSTR pShortGradeName, short* pPriceLevel , double* pPrice, double* pVolume, 
							   double* pValue, short* pStackSize ) ;
EZ_DLL_CALL GetNextDeliveryEventMT(CEZCLProcess* pCLProcess ,  long* pDeliveryID , long* pPumpID, short* pPumpNumber, long* pHoseID, short* pHoseNumber , 
								long* pGradeID, PBSTR pGradeName ,PBSTR pShortGradeName, short* pPriceLevel, double* pPrice, double* pVolume, double* pValue, 
								short* pDeliveryState , short* pDeliveryType, long* pLockedBy, long* pReservedBy, long* pAge , DATE* pCompletedDT , long* pAttendantID ) ;
EZ_DLL_CALL GetNextServerEventMT(CEZCLProcess* pCLProcess ,  long* pEventID, PBSTR pEventText ) ;
EZ_DLL_CALL GetNextClientEventMT(CEZCLProcess* pCLProcess ,  long* pClientID, long* pEventID, PBSTR pEventText ) ;
EZ_DLL_CALL GetNextDBLogEventMT(CEZCLProcess* pCLProcess ,  long* pEventType , long* pDeviceID , DATE* pEventDT , PBSTR pEventText ) ;
EZ_DLL_CALL GetNextDBLogDeliveryEventMT(CEZCLProcess* pCLProcess ,  long* pDeliveryID, long* pHoseID, short* pDeliveryState, short* pDeliveryType, double* pVolume, short* pPriceLevel, 
							 double* pPrice, double* pValue, double* pVolume2, long* pReservedBy , long* pAttendantID, DATE* pDeliveryDT ) ;
EZ_DLL_CALL GetNextDBClearDeliveryEventMT(CEZCLProcess* pCLProcess ,  long* pDeliveryID, short* pDeliveryType, long* pClearedBY, DATE* pClearedDT, long* pAttendantID ) ;
EZ_DLL_CALL GetNextDBStackDeliveryEventMT(CEZCLProcess* pCLProcess ,  long* pDeliveryID ) ;
EZ_DLL_CALL GetNextDBHoseETotalsEventMT(CEZCLProcess* pCLProcess ,  long* pHoseID , double* pVolume , double* pValue , double* pVolumeETot , double* pValueETot ) ;
EZ_DLL_CALL GetNextDBTriggerEventMT(CEZCLProcess* pCLProcess ,  long* pTableID ,long* pRowID ) ;
EZ_DLL_CALL GetNextDBAttendantLogonEventMT(CEZCLProcess* pCLProcess ,  long* pAttendantID ,long* pPumpID ) ;
EZ_DLL_CALL GetNextDBAttendantLogoffEventMT(CEZCLProcess* pCLProcess ,  long* pAttendantID ) ;
EZ_DLL_CALL GetNextDBTankStatusEventMT(CEZCLProcess* pCLProcess ,  long* pTankID , double* pGaugeVolume , double* pGaugeTCVolume, double* pGaugeUllage, double* pGaugeTemperature , 
							          double* pGaugeLevel , double* pGaugeWaterVolume, double* pGaugeWaterLevel ) ;
EZ_DLL_CALL GetPumpsCountMT(CEZCLProcess* pCLProcess ,  long* pCount ) ;
EZ_DLL_CALL GetPumpByNumberMT(CEZCLProcess* pCLProcess ,  long Number , long* pID ) ;
EZ_DLL_CALL GetPumpByNameMT(CEZCLProcess* pCLProcess ,  BSTR Name , long* pID ) ;
EZ_DLL_CALL GetPumpByOrdinalMT(CEZCLProcess* pCLProcess ,  long Index , long* pID ) ;
EZ_DLL_CALL GetPumpPropertiesMT(CEZCLProcess* pCLProcess , long ID , long* pNumber, PBSTR pName, short* pPhysicalNumber, short* pSide, short* pAddress, short* pPriceLevel1,
						      short* pPriceLevel2, short* pPriceDspFormat, short* pVolumeDspFormat, short* pValueDspFormat, short* pType,  
						      long* pPortID, long* pAttendantID, short* pAuthMode, short* pStackMode, short* pPrepayAllowed, short* pPreauthAllowed ) ;
EZ_DLL_CALL SetPumpPropertiesMT(CEZCLProcess* pCLProcess , long ID , long Number, BSTR Name, short PhysicalNumber, short Side, short Address, short PriceLevel1,
						      short PriceLevel2, short PriceDspFormat, short VolumeDspFormat, short ValueDspFormat, short Type, 
						      long PortID, long AttendantID, short AuthMode, short StackMode, short PrepayAllowed, short PreauthAllowed ) ;
EZ_DLL_CALL DeletePumpMT(CEZCLProcess* pCLProcess ,  long ID ) ;
EZ_DLL_CALL GetPumpHosesCountMT(CEZCLProcess* pCLProcess ,  long ID , long* pCount ) ;
EZ_DLL_CALL GetPumpHoseByNumberMT(CEZCLProcess* pCLProcess ,  long ID , long Number , long* pHoseID ) ;
EZ_DLL_CALL GetPumpStatusMT(CEZCLProcess* pCLProcess ,  long ID , short* pState, short* pReservedFor, long* pReservedBy, long* pHoseID, short* pHoseNumber , 
						   long* pGradeID, PBSTR pGradeName ,PBSTR pShortGradeName, short* pPriceLevel , double* pPrice , double* pVolume , double* pValue , 
						   short* pStackSize ) ;
EZ_DLL_CALL GetPumpStatusExMT( CEZCLProcess* pCLProcess , long ID , long* pPumpNumber, PBSTR pPumpName, long* pPhysicalNumber, short* pState, short* pReservedFor, long* pReservedBy, long* pHoseID, long* pHoseNumber , long* pHosePhysicalNumber , long* pGradeID , 
					   long* pGradeNumber , PBSTR pGradeName, PBSTR pShortGradeName, short* pPriceLevel , double* pPrice , double* pVolume , double* pValue , 
					   short* pStackSize , __int64* pTag , 
					   long* pAttendantID , long* pAttendantNumber , PBSTR pAttendantName, __int64* pAttendantTag ,
					   long* pCardClientID , long* pCardClientNumber , PBSTR pCardClientName, __int64* pCardClientTag ) ;

EZ_DLL_CALL GetPumpDeliveryPropertiesMT(CEZCLProcess* pCLProcess ,  long ID , short Index , long* pDeliveryID , short* pType , short* pState, long* pHoseID, 
									   short* pHoseNum, long* pGradeID , PBSTR pGradeName ,PBSTR pShortGradeName, short* pPriceLevel, double* pPrice , double* pVolume , 
									   double* pValue , long* pLockedBy , long* pReservedBy , long* pAge , DATE* pCompletedDT , long* pAttendantID  ) ;
EZ_DLL_CALL GetPumpDeliveryPropertiesExMT(CEZCLProcess* pCLProcess ,  long ID , short Index , long* pDeliveryID , short* pType , short* pState, long* pHoseID, short* pHoseNum, long* pGradeID, PBSTR pGradeName, PBSTR pShortGradeName , 
								        short* pPriceLevel, double* pPrice , double* pVolume , double* pValue , long* pLockedBy , 
									    long* pReservedBy , long* pAge , DATE* pCompletedDT , long* pAttendantID , double* pVolumeETot , double* pVolume2ETot , double* pValueETot , __int64* pTag ) ;
EZ_DLL_CALL GetPumpDeliveryPropertiesEx2MT( CEZCLProcess* pCLProcess , long ID , short Index , long* pDeliveryID , short* pType , short* pState, long* pHoseID, short* pHoseNum, long* pGradeID, PBSTR pGradeName, PBSTR pShortGradeName , 
								        short* pPriceLevel, double* pPrice , double* pVolume , double* pValue , long* pLockedBy , 
									    long* pReservedBy , long* pAge , DATE* pCompletedDT , long* pAttendantID , 
										double* pOldVolumeETot , double* pOldVolume2ETot , double* pOldValueETot , 
										double* pNewVolumeETot , double* pNewVolume2ETot , double* pNewValueETot , 
										__int64* pTag , long * pDuration ) ;
EZ_DLL_CALL GetPumpDeliveryPropertiesEx3MT( CEZCLProcess* pCLProcess , long ID , short Index , long* pDeliveryID , short* pType , short* pState, 
										   long* pHoseID, short* pHoseNum, 
										   long* pGradeID, PBSTR pGradeName, PBSTR pShortGradeName , 
								        short* pPriceLevel, double* pPrice , double* pVolume , double* pValue , long* pLockedBy , 
									    long* pReservedBy , long* pAge , DATE* pCompletedDT , long* pAttendantID , 
										double* pOldVolumeETot , double* pOldVolume2ETot , double* pOldValueETot , 
										double* pNewVolumeETot , double* pNewVolume2ETot , double* pNewValueETot , 
										__int64* pTag , long * pDuration , long* pCardClientID ) ;
EZ_DLL_CALL PrepayReserveMT(CEZCLProcess* pCLProcess ,  long ID ) ;
EZ_DLL_CALL PrepayCancelMT(CEZCLProcess* pCLProcess ,  long ID  ) ;
EZ_DLL_CALL PrepayAuthoriseMT(CEZCLProcess* pCLProcess ,  long ID , short LimitType , double Value , short Hose , short PriceLevel ) ;
EZ_DLL_CALL PreauthReserveMT(CEZCLProcess* pCLProcess ,  long ID ) ;
EZ_DLL_CALL PreauthCancelMT(CEZCLProcess* pCLProcess ,  long ID ) ;
EZ_DLL_CALL PreauthAuthoriseMT(CEZCLProcess* pCLProcess ,  long ID , short LimitType , double Value , short Hose , short PriceLevel ) ;
EZ_DLL_CALL LoadPresetMT(CEZCLProcess* pCLProcess ,  long ID , short LimitType , double Value , short Hose , short PriceLevel ) ;
EZ_DLL_CALL LoadPresetWithPriceMT(CEZCLProcess* pCLProcess ,  long ID , short LimitType , double Value , short Hose , short PriceLevel , double Price ) ;
EZ_DLL_CALL TagAuthoriseMT(CEZCLProcess* pCLProcess ,  long ID , __int64 Tag , short LimitType , double Value , short Hose , short PriceLevel ) ;
EZ_DLL_CALL AttendantAuthoriseMT(CEZCLProcess* pCLProcess ,  long ID , long AttendantID ) ;
EZ_DLL_CALL AuthoriseMT(CEZCLProcess* pCLProcess ,  long ID ) ;
EZ_DLL_CALL CancelAuthoriseMT(CEZCLProcess* pCLProcess ,  long ID ) ;
EZ_DLL_CALL TempStopMT(CEZCLProcess* pCLProcess ,  long ID ) ;
EZ_DLL_CALL ReAuthoriseMT(CEZCLProcess* pCLProcess ,  long ID ) ;
EZ_DLL_CALL TerminateDeliveryMT(CEZCLProcess* pCLProcess ,  long ID ) ;
EZ_DLL_CALL StackCurrentDeliveryMT(CEZCLProcess* pCLProcess ,  long ID ) ;
EZ_DLL_CALL GetDensityMT( CEZCLProcess* pCLProcess , long ID , double* pDensity ) ;
EZ_DLL_CALL EnablePumpMT( CEZCLProcess* pCLProcess , long ID ) ;
EZ_DLL_CALL DisablePumpMT( CEZCLProcess* pCLProcess , long ID ) ;
EZ_DLL_CALL GetHosesCountMT(CEZCLProcess* pCLProcess ,  long* pCount ) ;
EZ_DLL_CALL GetHoseByOrdinalMT(CEZCLProcess* pCLProcess ,  long Index , long* pID ) ;
EZ_DLL_CALL GetHosePropertiesMT(CEZCLProcess* pCLProcess , long ID , long* pNumber, long* pPumpID ,long* pTankID , long* pPhysicalNumber, 
		                      double* pMtrTheoValue , double* pMtrTheoVolume ,double* pMtrElecValue ,
				              double* pMtrElecVolume ) ;
EZ_DLL_CALL SetHosePropertiesMT(CEZCLProcess* pCLProcess , long ID , long Number,long PumpID, long TankID , long PhysicalNumber, 
		                      double MtrTheoValue , double MtrTheoVolume ,double MtrElecValue ,
				              double MtrElecVolume ) ;
EZ_DLL_CALL GetHoseSummaryMT(CEZCLProcess* pCLProcess , 	long ID , long* pNumber, long* pPhysicalNumber,
							long* pPumpID, long* pPumpNumber, PBSTR pPumpName,
							long* pTankID, long* pTankNumber, PBSTR pTankName,
							long* pGradeID , long* pGradeNumber, PBSTR pGradeName, PBSTR pGradeShortName, PBSTR pGradeCode,
		                    double* pMtrTheoValue , double* pMtrTheoVolume ,double* pMtrElecValue , double* pMtrElecVolume ) ;
EZ_DLL_CALL GetHoseSummaryExMT(CEZCLProcess* pCLProcess , long ID , long* pNumber, long* pPhysicalNumber,
							long* pPumpID, long* pPumpNumber, PBSTR pPumpName,
							long* pTankID, long* pTankNumber, PBSTR pTankName,
							long* pGradeID , long* pGradeNumber, PBSTR pGradeName, PBSTR pGradeShortName, PBSTR pGradeCode,
		                    double* pMtrTheoValue , double* pMtrTheoVolume ,double* pMtrElecValue , double* pMtrElecVolume ,
							double* pPrice1 , double* pPrice2 , short* pEnabled ) ;
EZ_DLL_CALL DeleteHoseMT(CEZCLProcess* pCLProcess ,  long ID ) ;
EZ_DLL_CALL GetDeliveriesCountMT(CEZCLProcess* pCLProcess ,  long* pCount ) ;
EZ_DLL_CALL GetDeliveryByOrdinalMT(CEZCLProcess* pCLProcess ,  long Index , long* pID ) ;
EZ_DLL_CALL GetAllDeliveriesCountMT(CEZCLProcess* pCLProcess ,  long* pCount )  ;
EZ_DLL_CALL GetAllDeliveryByOrdinalMT(CEZCLProcess* pCLProcess ,  long Index , long* pID ) ;

EZ_DLL_CALL AckDeliveryDBLogMT(CEZCLProcess* pCLProcess , long ID ) ; 
EZ_DLL_CALL GetDeliveryIDByOrdinalNotLoggedMT(CEZCLProcess* pCLProcess , long Ordinal , long* pID ) ;
EZ_DLL_CALL GetDeliveriesCountNotLoggedMT(CEZCLProcess* pCLProcess , long* pCount ) ;

EZ_DLL_CALL AckDeliveryVolLogMT(CEZCLProcess* pCLProcess , long ID ) ; 
EZ_DLL_CALL GetDeliveryIDByOrdinalNotVolLoggedMT(CEZCLProcess* pCLProcess , long Ordinal , long* pID ) ;
EZ_DLL_CALL GetDeliveriesCountNotVolLoggedMT(CEZCLProcess* pCLProcess , long* pCount ) ;


EZ_DLL_CALL GetDeliveryPropertiesMT(CEZCLProcess* pCLProcess ,  long ID , long* pHoseID ,short* pState ,short* pType ,double* pVolume ,
								   short* pPriceLevel ,double* pPrice ,double* pValue ,double* pVolume2 , 
								   DATE* pCompletedDT ,long* pLockedBy , long* pReservedBy , long* pAttendantID , long* pAge ) ;
EZ_DLL_CALL GetDeliveryPropertiesExMT(CEZCLProcess* pCLProcess ,  long ID , long* pHoseID ,short* pState ,short* pType ,double* pVolume ,short* pPriceLevel ,
		                           double* pPrice ,double* pValue ,double* pVolume2 , DATE* pCompletedDT ,long* pLockedBy, long* pReservedBy , long* pAttendantID , long* pAge , 
								   DATE* pClearedDT ,double* pVolumeETot , double* pVolume2ETot , double* pValueETot , __int64* pTag ) ;
EZ_DLL_CALL GetDeliveryPropertiesEx2MT( CEZCLProcess* pCLProcess , long ID , long* pHoseID ,short* pState ,short* pType ,double* pVolume ,short* pPriceLevel ,
										double* pPrice ,double* pValue ,double* pVolume2 , DATE* pCompletedDT ,long* pLockedBy, long* pReservedBy , 
										long* pAttendantID , long* pAge , DATE* pClearedDT ,
										double* pOldVolumeETot , double* pOldVolume2ETot , double* pOldValueETot , 
										double* pNewVolumeETot , double* pNewVolume2ETot , double* pNewValueETot , 
										__int64* pTag , long * pDuration ) ;
EZ_DLL_CALL GetDeliveryPropertiesEx3MT( CEZCLProcess* pCLProcess , long ID , long* pHoseID ,short* pState ,short* pType ,double* pVolume ,short* pPriceLevel ,
										double* pPrice ,double* pValue ,double* pVolume2 , DATE* pCompletedDT ,long* pLockedBy, long* pReservedBy , 
										long* pAttendantID , long* pAge , DATE* pClearedDT ,
										double* pOldVolumeETot , double* pOldVolume2ETot , double* pOldValueETot , 
										double* pNewVolumeETot , double* pNewVolume2ETot , double* pNewValueETot , 
										__int64* pTag , long * pDuration , long* pCardClientID ) ;
EZ_DLL_CALL SetDeliveryPropertiesMT(CEZCLProcess* pCLProcess ,  long ID , long HoseID ,short State ,short Type ,double Volume ,short PriceLevel ,
								   double Price ,double Value ,double Volume2, DATE CompletedDT ,long LockedBy, long ReservedBy , 
								   long AttendantID , long Age ) ;
EZ_DLL_CALL SetDeliveryPropertiesExMT(CEZCLProcess* pCLProcess ,  long ID , long HoseID ,short State ,short Type ,double Volume ,short PriceLevel ,
								   double Price ,double Value ,double Volume2 , DATE CompletedDT ,long LockedBy, 
								   long ReservedBy , long AttendantID , long Age , DATE ClearedDT , double VolumeETot , double Volume2ETot , double ValueETot , __int64 Tag ) ;
EZ_DLL_CALL SetDeliveryPropertiesEx2MT( CEZCLProcess* pCLProcess , long ID , long HoseID ,short State ,short Type ,double Volume ,short PriceLevel ,
								   double Price ,double Value ,double Volume2 , DATE CompletedDT ,long LockedBy, 
								   long ReservedBy , long AttendantID , long Age , DATE ClearedDT , 
								   double OldVolumeETot , double OldVolume2ETot , double OldValueETot , 
								   double NewVolumeETot , double NewVolume2ETot , double NewValueETot , 
								   __int64 Tag , long Duration ) ;
EZ_DLL_CALL SetDeliveryPropertiesEx3MT( CEZCLProcess* pCLProcess , long ID , long HoseID ,short State ,short Type ,double Volume ,short PriceLevel ,
								   double Price ,double Value ,double Volume2 , DATE CompletedDT ,long LockedBy, 
								   long ReservedBy , long AttendantID , long Age , DATE ClearedDT , 
								   double OldVolumeETot , double OldVolume2ETot , double OldValueETot , 
								   double NewVolumeETot , double NewVolume2ETot , double NewValueETot , 
								   __int64 Tag , long Duration , long CardClientID ) ;
EZ_DLL_CALL GetDeliverySummaryMT(CEZCLProcess* pCLProcess ,  long ID , long* pHoseID ,long* pHoseNumber, long* pHosePhysicalNumber,
	  							long* pPumpID, long* pPumpNumber, PBSTR  pPumpName,
								long* pTankID, long* pTankNumber, PBSTR  pTankName,
								long* pGradeID , long* pGradeNumber, PBSTR  pGradeName, PBSTR  pGradeShortName, PBSTR  pGradeCode,
								short* pState ,short* pType ,double* pVolume ,short* pPriceLevel ,
								double* pPrice ,double* pValue ,double* pVolume2 , DATE* pCompletedDT ,long* pLockedBy, 
								long* pReservedBy , long* pAttendantID , long* pAge ,DATE* pClearedDT ,
								double* pVolumeETot , double* pVolume2ETot , double* pValueETot , __int64* pTag) ;
EZ_DLL_CALL GetDeliverySummaryExMT( CEZCLProcess* pCLProcess , long ID , long* pHoseID ,long* pHoseNumber, long* pHosePhysicalNumber,
	  							long* pPumpID, long* pPumpNumber, PBSTR  pPumpName,
								long* pTankID, long* pTankNumber, PBSTR  pTankName,
								long* pGradeID , long* pGradeNumber, PBSTR  pGradeName, PBSTR  pGradeShortName, PBSTR  pGradeCode,
							    short* pState ,short* pType ,double* pVolume ,short* pPriceLevel ,
		                        double* pPrice ,double* pValue ,double* pVolume2 , DATE* pCompletedDT ,long* pLockedBy, 
								long* pReservedBy , long* pAttendantID , long* pAge ,DATE* pClearedDT ,
								double* pOldVolumeETot , double* pOldVolume2ETot , double* pOldValueETot , 
								double* pNewVolumeETot , double* pNewVolume2ETot , double* pNewValueETot , 
								__int64* pTag , long * pDuration ) ;
EZ_DLL_CALL GetDeliverySummaryEx2MT( CEZCLProcess* pCLProcess , long ID , long* pHoseID ,long* pHoseNumber, long* pHosePhysicalNumber,
	  							long* pPumpID, long* pPumpNumber, PBSTR  pPumpName,
								long* pTankID, long* pTankNumber, PBSTR  pTankName,
								long* pGradeID , long* pGradeNumber, PBSTR  pGradeName, PBSTR  pGradeShortName, PBSTR  pGradeCode,
							    short* pState ,short* pType ,double* pVolume ,short* pPriceLevel ,
		                        double* pPrice ,double* pValue ,double* pVolume2 , DATE* pCompletedDT ,long* pLockedBy, 
								long* pReservedBy , long* pAttendantID , long* pAge ,DATE* pClearedDT ,
								double* pOldVolumeETot , double* pOldVolume2ETot , double* pOldValueETot , 
								double* pNewVolumeETot , double* pNewVolume2ETot , double* pNewValueETot , 
								__int64* pTag , long * pDuration , long* pAttendantNumber , PBSTR pAttendantName, __int64* pAttendantTag ,
								long* pCardClientID , long* pCardClientNumber , PBSTR pCardClientName, __int64* pCardClientTag ) ;
EZ_DLL_CALL LockDeliveryMT(CEZCLProcess* pCLProcess ,  long ID ) ;
EZ_DLL_CALL UnlockDeliveryMT(CEZCLProcess* pCLProcess ,  long ID ) ;
EZ_DLL_CALL ClearDeliveryMT(CEZCLProcess* pCLProcess ,  long ID , short Type ) ;
EZ_DLL_CALL LockAndClearDeliveryMT(CEZCLProcess* pCLProcess ,  long ID , short Type ) ;
EZ_DLL_CALL GetDurationMT( CEZCLProcess* pCLProcess , long ID , long* pDuration ) ;
EZ_DLL_CALL GetGradesCountMT(CEZCLProcess* pCLProcess ,  long* pCount ) ;
EZ_DLL_CALL GetGradeByNumberMT(CEZCLProcess* pCLProcess ,  long Number , long* pID ) ;
EZ_DLL_CALL GetGradeByNameMT(CEZCLProcess* pCLProcess ,  BSTR Name , long* pID ) ;
EZ_DLL_CALL GetGradeByOrdinalMT(CEZCLProcess* pCLProcess ,  long Index , long* pID ) ;
EZ_DLL_CALL GetGradePropertiesMT(CEZCLProcess* pCLProcess , long ID , long* pNumber, PBSTR pName , PBSTR pShortName , PBSTR pCode ) ;
EZ_DLL_CALL SetGradePropertiesMT(CEZCLProcess* pCLProcess , long ID , long Number, BSTR Name , BSTR ShortName , BSTR Code  ) ;
EZ_DLL_CALL DeleteGradeMT(CEZCLProcess* pCLProcess ,  long ID ) ;
EZ_DLL_CALL SetGradePriceMT(CEZCLProcess* pCLProcess ,  long ID , short Level , double Price ) ;
EZ_DLL_CALL GetGradePriceMT(CEZCLProcess* pCLProcess ,  long ID , short Level , double* pPrice ) ;
EZ_DLL_CALL GetTanksCountMT(CEZCLProcess* pCLProcess ,  long* pCount ) ;
EZ_DLL_CALL GetTankByNumberMT(CEZCLProcess* pCLProcess ,  long Number , long* pID ) ;
EZ_DLL_CALL GetTankByNameMT(CEZCLProcess* pCLProcess ,  BSTR Name , long* pID ) ;
EZ_DLL_CALL GetTankByOrdinalMT(CEZCLProcess* pCLProcess ,  long Index , long* pID ) ;
EZ_DLL_CALL GetTankPropertiesMTMT(CEZCLProcess* pCLProcess , long ID , long* pNumber, PBSTR pName , long* pGradeID , short* pType , double* pCapacity , double* pDiameter , 
							  double* pTheoVolume , double* pGaugeVolume , double* pGaugeTCVolume, double* pGaugeUllage, double* pGaugeTemperature , 
							  double* pGaugeLevel , double* pGaugeWaterVolume, double* pGaugeWaterLevel, long* pGaugeID, short* pProbeNo ) ;
EZ_DLL_CALL SetTankPropertiesMT(CEZCLProcess* pCLProcess , long ID , long Number, BSTR Name , long GradeID , short Type , double Capacity , double Diameter , double TheoVolume , 
		                      double GaugeVolume , double GaugeTCVolume ,double GaugeUllage ,double GaugeTemperature , double GaugeLevel , 
							  double GaugeWaterVolume, double GaugeWaterLevel, long GaugeID , short ProbeNo ) ;
EZ_DLL_CALL GetTankSummaryMT(CEZCLProcess* pCLProcess , long ID , long* pNumber, PBSTR pName , long* pGradeID , 
						   long* pGradeNumber, PBSTR pGradeName, PBSTR pGradeShortName, PBSTR pGradeCode, 
						   short* pType , double* pCapacity , double* pDiameter , 
						   double* pTheoVolume , double* pGaugeVolume , double* pGaugeTCVolume, double* pGaugeUllage, double* pGaugeTemperature , 
						   double* pGaugeLevel , double* pGaugeWaterVolume, double* pGaugeWaterLevel, long* pGaugeID, short* pProbeNo ) ;
EZ_DLL_CALL TankDropMT(CEZCLProcess* pCLProcess ,  long ID , double Volume , DATE DropDT , BSTR Terminal , BSTR DocumentType , DATE DocumentDT  , BSTR DocumentFolio , double PEMEXVolume ) ;
EZ_DLL_CALL DeleteTankMT(CEZCLProcess* pCLProcess ,  long ID ) ;
EZ_DLL_CALL GetPortsCountMT(CEZCLProcess* pCLProcess ,  long* pCount ) ;
EZ_DLL_CALL GetPortByNumberMT(CEZCLProcess* pCLProcess ,  long Number , long* pID ) ;
EZ_DLL_CALL GetPortByNameMT(CEZCLProcess* pCLProcess ,  BSTR Name , long* pID ) ;
EZ_DLL_CALL GetPortByOrdinalMT(CEZCLProcess* pCLProcess ,  long Index , long* pID ) ;
EZ_DLL_CALL GetPortPropertiesMT(CEZCLProcess* pCLProcess , long ID , long* pNumber, PBSTR pName , long* pProtocolID , short* pDeviceType , PBSTR pSerialNo ) ;
EZ_DLL_CALL SetPortPropertiesMT(CEZCLProcess* pCLProcess , long ID , long Number, BSTR Name, long ProtocolID , short DeviceType , BSTR SerialNo ) ;
EZ_DLL_CALL DeletePortMT(CEZCLProcess* pCLProcess ,  long ID ) ;
EZ_DLL_CALL GetAttendantsCountMT(CEZCLProcess* pCLProcess ,  long* pCount ) ;
EZ_DLL_CALL GetAttendantByNumberMT(CEZCLProcess* pCLProcess ,  long Number , long* pID ) ;
EZ_DLL_CALL GetAttendantByNameMT(CEZCLProcess* pCLProcess ,  BSTR Name , long* pID ) ;
EZ_DLL_CALL GetAttendantByOrdinalMT(CEZCLProcess* pCLProcess ,  long Index , long* pID ) ;
EZ_DLL_CALL GetAttendantPropertiesMT(CEZCLProcess* pCLProcess , long ID , long* pNumber, PBSTR pName , PBSTR pShortName , PBSTR pPassword ) ; 
EZ_DLL_CALL SetAttendantPropertiesMT(CEZCLProcess* pCLProcess , long ID , long Number, BSTR Name , BSTR ShortName , BSTR Password ) ; 
EZ_DLL_CALL SetAttendantPropertiesExMT(CEZCLProcess* pCLProcess , long ID , long Number, BSTR Name , BSTR ShortName , BSTR Password , BSTR Tag ,
									short ShiftAStart , short ShiftAEnd , short ShiftBStart , short ShiftBEnd , short Enabled )  ;
EZ_DLL_CALL GetAttendantPropertiesExMT(CEZCLProcess* pCLProcess , long ID , long* pNumber, PBSTR pName , PBSTR pShortName , PBSTR pPassword , PBSTR pTag , 
									   short* pShiftAStart , short* pShiftAEnd , short* pShiftBStart , short* pShiftBEnd , short* pEnabled ) ; 
EZ_DLL_CALL DeleteAttendantMT(CEZCLProcess* pCLProcess ,  long ID ) ;
EZ_DLL_CALL AttendantLogonMT(CEZCLProcess* pCLProcess ,  long ID , long PumpID ) ;
EZ_DLL_CALL AttendantLogoffMT(CEZCLProcess* pCLProcess ,  long ID ) ;

EZ_DLL_CALL GetCardReadsCountMT( CEZCLProcess* pCLProcess , long* pCount ) ;
EZ_DLL_CALL GetCardReadByNumberMT( CEZCLProcess* pCLProcess , long Number , long* pID ) ;
EZ_DLL_CALL GetCardReadByNameMT( CEZCLProcess* pCLProcess , BSTR Name , long* pID ) ;
EZ_DLL_CALL GetCardReadByOrdinalMT( CEZCLProcess* pCLProcess , long Index , long* pID ) ;
EZ_DLL_CALL GetCardReadPropertiesMT(CEZCLProcess* pCLProcess , long ID , long* pNumber, PBSTR pName , long* pPumpID , short* pType , long* pParentID , PBSTR pTag , DATE* pTimeStamp  )  ;
EZ_DLL_CALL SetCardReadPropertiesMT(CEZCLProcess* pCLProcess , long ID , long Number, BSTR Name , long PumpID , short Type , long ParentID , BSTR Tag , DATE TimeStamp )  ;
EZ_DLL_CALL DeleteCardReadMT( CEZCLProcess* pCLProcess , long ID ) ;
EZ_DLL_CALL GetCardClientsCountMT( CEZCLProcess* pCLProcess , long* pCount ) ;
EZ_DLL_CALL GetCardClientByNumberMT( CEZCLProcess* pCLProcess , long Number , long* pID ) ;
EZ_DLL_CALL GetCardClientByNameMT( CEZCLProcess* pCLProcess , BSTR Name , long* pID ) ;
EZ_DLL_CALL GetCardClientByOrdinalMT( CEZCLProcess* pCLProcess , long Index , long* pID ) ;
EZ_DLL_CALL GetCardClientPropertiesMT(CEZCLProcess* pCLProcess , long ID , long* pNumber, PBSTR pName , PBSTR pTag , short* pEnabled  )  ;
EZ_DLL_CALL SetCardClientPropertiesMT(CEZCLProcess* pCLProcess , long ID , long Number, BSTR Name , BSTR Tag , short Enabled  )  ;
EZ_DLL_CALL DeleteCardClientMT( CEZCLProcess* pCLProcess , long ID ) ;

EZ_DLL_CALL AllStopMT(CEZCLProcess* pCLProcess ) ;
EZ_DLL_CALL AllAuthoriseMT(CEZCLProcess* pCLProcess ) ;
EZ_DLL_CALL AllReAuthoriseMT(CEZCLProcess* pCLProcess ) ;
EZ_DLL_CALL AllStopIfIdleMT(CEZCLProcess* pCLProcess ) ;
EZ_DLL_CALL ReadAllTanksMT(CEZCLProcess* pCLProcess ) ;
EZ_DLL_CALL GetAllPumpStatusesMT(CEZCLProcess* pCLProcess ,  PBSTR pStates , PBSTR pCurrentHoses , PBSTR pDeliveriesCount ) ; 
EZ_DLL_CALL GetIniValueMT(CEZCLProcess* pCLProcess ,  BSTR Section , BSTR Key , PBSTR pValue ) ; 
EZ_DLL_CALL SetIniValueMT(CEZCLProcess* pCLProcess ,  BSTR Section , BSTR Key , BSTR Value ) ; 
EZ_DLL_CALL SetNextDeliveryIDMT(CEZCLProcess* pCLProcess ,  long ID ) ;
EZ_DLL_CALL RemovePortMT(CEZCLProcess* pCLProcess ,  long ID ) ;
EZ_DLL_CALL LicenseStatusMT(CEZCLProcess* pCLProcess ) ;
EZ_DLL_CALL CheckSocketClosedMT(CEZCLProcess* pCLProcess ,  LPARAM lParam ) ;

// *** new APIS
EZ_DLL_CALL GetNextPumpEventExMT(CEZCLProcess* pCLProcess ,  long* pPumpID, short* pPumpNumber, short* pState, short* pReservedFor, long* pReservedBy, long* pHoseID ,
							    short* pHoseNumber,long* pGradeID, PBSTR pGradeName , PBSTR pShortGradeName, short* pPriceLevel , double* pPrice, double* pVolume, 
							    double* pValue, short* pStackSize , PBSTR pPumpName , short* pPhysicalNumber , short* pSide , short* pAddress, 
								short* pPriceLevel1 , short* pPriceLevel2 , short* pType , long* pPortID , short* pAuthMode , short* pStackMode ,  short* pPrepayAllowed, 
								short* pPreauthAllowed ,  short* pPriceFormat , short* pValueFormat , short* pVolumeFormat  ) ;

EZ_DLL_CALL GetNextDeliveryEventExMT(CEZCLProcess* pCLProcess ,  long* pDeliveryID , long* pPumpID, short* pPumpNumber, long* pHoseID, short* pHoseNumber , 
								    long* pGradeID, PBSTR pGradeName , PBSTR pShortGradeName, short* pPriceLevel, double* pPrice, 
									double* pVolume, double* pValue, short* pDeliveryState , 
								    short* pDeliveryType, long* pLockedBy, long* pReservedBy, long* pAge , DATE* pCompletedDT , 
									long* pAttendantID, double* pVolumeETot , double* pVolume2ETot , double* pValueETot , __int64* pTag) ;

EZ_DLL_CALL GetNextPumpEventEx2MT( CEZCLProcess* pCLProcess , long* pPumpID, long* pPumpNumber, short* pState, short* pReservedFor, long* pReservedBy, long* pHoseID ,
							    long* pHoseNumber, long* pHosePhysicalNumber,long* pGradeID,long* pGradeNumber, PBSTR pGradeName , PBSTR pShortGradeName, short* pPriceLevel , double* pPrice, double* pVolume, 
							    double* pValue, short* pStackSize , PBSTR pPumpName , long* pPhysicalNumber , short* pSide , short* pAddress, 
								short* pPriceLevel1 , short* pPriceLevel2 , short* pType , long* pPortID , short* pAuthMode , short* pStackMode ,  short* pPrepayAllowed, 
								short* pPreauthAllowed ,  short* pPriceFormat , short* pValueFormat , short* pVolumeFormat , __int64* pTag , 
							    long* pAttendantID , long* pAttendantNumber , PBSTR pAttendantName, __int64* pAttendantTag ,
							    long* pCardClientID , long* pCardClientNumber , PBSTR pCardClientName, __int64* pCardClientTag ) ;

EZ_DLL_CALL  GetNextDeliveryEventEx2MT( CEZCLProcess* pCLProcess , long* pDeliveryID , long* pPumpID, short* pPumpNumber, long* pHoseID, short* pHoseNumber , 
								     long* pGradeID, PBSTR pGradeName , PBSTR pShortGradeName, short* pPriceLevel, double* pPrice, 
									 double* pVolume, double* pValue, short* pDeliveryState , 
								     short* pDeliveryType, long* pLockedBy, long* pReservedBy, long* pAge , DATE* pCompletedDT , 
									 long* pAttendantID, 
									 double* pOldVolumeETot , double* pOldVolume2ETot , double* pOldValueETot , 
									 double* pNewVolumeETot , double* pNewVolume2ETot , double* pNewValueETot , 
									 __int64* pTag , long* pDuration ) ;

EZ_DLL_CALL  GetNextDeliveryEventEx3MT( CEZCLProcess* pCLProcess , long* pDeliveryID , long* pPumpID, short* pPumpNumber, long* pHoseID, short* pHoseNumber , 
								     long* pGradeID, PBSTR pGradeName , PBSTR pShortGradeName, short* pPriceLevel, double* pPrice, 
									 double* pVolume, double* pValue, short* pDeliveryState , 
								     short* pDeliveryType, long* pLockedBy, long* pReservedBy, long* pAge , DATE* pCompletedDT , 
									 long* pAttendantID, 
									 double* pOldVolumeETot , double* pOldVolume2ETot , double* pOldValueETot , 
									 double* pNewVolumeETot , double* pNewVolume2ETot , double* pNewValueETot , 
									 __int64* pTag , long* pDuration , long* pAttendantNumber , PBSTR pAttendantName, __int64* pAttendantTag ,
									 long* pCardClientID , long* pCardClientNumber , PBSTR pCardClientName, __int64* pCardClientTag ) ;

EZ_DLL_CALL GetNextCardReadEventMT( CEZCLProcess* pCLProcess , long* pCardReadID , long* pNumber, PBSTR pName , long* pPumpID , short* pType , long* pParentID , __int64* pTag , DATE* pTimeStamp ) ;
EZ_DLL_CALL GetNextDBHoseETotalsEventExMT(CEZCLProcess* pCLProcess ,  long* pHoseID , double* pVolume , double* pValue , double* pVolumeETot , double* pValueETot , 
										 long* pHoseNumber , long* pHosePhysicalNumber , long* pPumpID , long* pPumpNumber , PBSTR pPumpName , 
										 long* pTankID , long* pTankNumber , PBSTR pTankName , long* pGradeID , PBSTR pGradeName ) ;
EZ_DLL_CALL GetNextDBTankStatusEventExMT(CEZCLProcess* pCLProcess ,  long* pTankID , double* pGaugeVolume , double* pGaugeTCVolume, double* pGaugeUllage, 
									    double* pGaugeTemperature , double* pGaugeLevel , double* pGaugeWaterVolume, double* pGaugeWaterLevel , 
									    long* pTankNumber , PBSTR pTankName , long* pGradeID , PBSTR pGradeName , short*pType  , 
										double* pCapacity , double* pDiameter , long* pGaugeID , short* pProbeNo) ;
EZ_DLL_CALL GetNextSerialPortEventMT(CEZCLProcess* pCLProcess ,  long* pPortID , long* pZBID , short* pSlot , short* pResult , PBSTR pRxMsg ) ; 
EZ_DLL_CALL GetNextZBEventMT(CEZCLProcess* pCLProcess ,  long* pPortID , long* pZBID , __int64* pZBAddress, short* pResult , short* pMsgType , PBSTR pRxMsg ) ; 
EZ_DLL_CALL GetNextUVEEventMT(CEZCLProcess* pCLProcess ,  long* pPumpID , long* pPumpNumber , long* pHoseID , long* pHoseNumber , PBSTR pUVE ) ;
EZ_DLL_CALL GetZigBeeCountMT(CEZCLProcess* pCLProcess ,  long* pCount ) ;
EZ_DLL_CALL GetZigBeeByNumberMT(CEZCLProcess* pCLProcess ,  long Number , long* pID ) ;
EZ_DLL_CALL GetZigBeeByNameMT(CEZCLProcess* pCLProcess ,  BSTR Name , long* pID ) ;
EZ_DLL_CALL GetZigBeeByOrdinalMT(CEZCLProcess* pCLProcess ,  long Index , long* pID ) ;
EZ_DLL_CALL GetZigBeePropertiesMT(CEZCLProcess* pCLProcess , long ID , long* pNumber, PBSTR pName , short* pDeviceType , PBSTR pSerialNumber , PBSTR pNodeIdentifier , long* pPortID ) ;
EZ_DLL_CALL SetZigBeePropertiesMT(CEZCLProcess* pCLProcess , long ID , long Number, BSTR Name , short DeviceType , BSTR SerialNumber , BSTR NodeIdentifier , long PortID ) ;
EZ_DLL_CALL DeleteZigBeeMT(CEZCLProcess* pCLProcess ,  long ID ) ;
EZ_DLL_CALL GetHosePropertiesExMT(CEZCLProcess* pCLProcess , long ID , long* pNumber, long* pPumpID ,long* pTankID , long* pPhysicalNumber, 
		                      double* pMtrTheoValue , double* pMtrTheoVolume ,double* pMtrElecValue ,
				              double* pMtrElecVolume , short* pUVEAntenna ) ;

EZ_DLL_CALL SetHosePropertiesExMT(CEZCLProcess* pCLProcess , long ID , long Number,long PumpID, long TankID , long PhysicalNumber, 
		                      double MtrTheoValue , double MtrTheoVolume ,double MtrElecValue ,
				              double MtrElecVolume , short UVEAntenna );

EZ_DLL_CALL SetHosePropertiesEx2MT(CEZCLProcess* pCLProcess , long ID , long Number,long PumpID, long TankID , long PhysicalNumber, 
		                      double MtrTheoValue , double MtrTheoVolume ,double MtrElecValue ,
				              double MtrElecVolume , short UVEAntenna , double Price1 , double Price2 , short Enabled ) ;

EZ_DLL_CALL GetHosePropertiesEx2MT(CEZCLProcess* pCLProcess , long ID , long* pNumber, long* pPumpID ,long* pTankID , long* pPhysicalNumber, 
		                      double* pMtrTheoValue , double* pMtrTheoVolume ,double* pMtrElecValue ,
				              double* pMtrElecVolume , short* pUVEAntenna , double* pPrice1 , double* pPrice2 , short* pEnabled ) ;


EZ_DLL_CALL SetPumpPropertiesExMT(CEZCLProcess* pCLProcess , long ID , long Number, BSTR Name, short PhysicalNumber, short Side, short Address, short PriceLevel1,
						        short PriceLevel2, short PriceDspFormat, short VolumeDspFormat, short ValueDspFormat, short Type, 
						        long PortID, long AttendantID, short AuthMode, short StackMode, short PrepayAllowed, short PreauthAllowed , 
								long SlotZigBeeID , long MuxSlotZigBeeID , short PriceControl , short HasPreset ) ;
EZ_DLL_CALL GetPumpPropertiesExMT(CEZCLProcess* pCLProcess , long ID , long* pNumber, PBSTR pName, short* pPhysicalNumber, short* pSide, short* pAddress, short* pPriceLevel1,
						      short* pPriceLevel2, short* pPriceDspFormat, short* pVolumeDspFormat, short* pValueDspFormat, short* pType, 
						      long* pPortID, long* pAttendantID, short* pAuthMode, short* pStackMode, short* pPrepayAllowed, short* pPreauthAllowed ,
							  long* pSlotZigBeeID , long* pMuxSlotZigBeeID , short* pPriceControl , short* pHasPreset) ;
EZ_DLL_CALL CTFReserveMT(CEZCLProcess* pCLProcess ,  long ID ) ;
EZ_DLL_CALL CTFCancelMT(CEZCLProcess* pCLProcess ,  long ID ) ;
EZ_DLL_CALL CTFAuthoriseMT(CEZCLProcess* pCLProcess ,  long ID , short LimitType , double Value , double Value2 , short Hose , short PriceLevel , BSTR UVE , short UVEType , short UVETimeout, short IBMPulserTimeout, short StopDelay ) ;
EZ_DLL_CALL GetSerialNoMT(CEZCLProcess* pCLProcess ,  long ID , PBSTR pSerialNo ) ; 
EZ_DLL_CALL GetDeviceDetailsMT(CEZCLProcess* pCLProcess ,  long ID , long ZBID , PBSTR pSerialNo , PBSTR pBootVersion , PBSTR pFirmwareVersion ) ;
EZ_DLL_CALL ResetDeviceMT(CEZCLProcess* pCLProcess ,  long ID , long ZBID ) ;
EZ_DLL_CALL RequestVersionMT(CEZCLProcess* pCLProcess ,  long ID , long ZBID ) ;
EZ_DLL_CALL ZBRegisterInterestMT(CEZCLProcess* pCLProcess ,  long ID , long ZBID ) ; 
EZ_DLL_CALL ZBExceptionRegisterInterestMT(CEZCLProcess* pCLProcess ,  long ID ) ;
EZ_DLL_CALL ZBHeartBeatRegisterInterestMT(CEZCLProcess* pCLProcess ,  long ID ) ;
EZ_DLL_CALL SerialPortSendMT(CEZCLProcess* pCLProcess ,  long ID , long ZBID , short Slot , short Type , BSTR TxMsg ) ;
EZ_DLL_CALL SerialPortConfigMT(CEZCLProcess* pCLProcess ,  long ID , long ZBID , short Slot , short COMPort , long BPS , short DataBits , short Parity , short StopBits , short ResponseMaxLen , short ResponseTimeout , short ResponseInterCharTimeout ) ;
EZ_DLL_CALL ZBSendMT(CEZCLProcess* pCLProcess ,  long ID , long ZBID, __int64 ZBAddress, short MsgType , BSTR TxMsg ) ; 
EZ_DLL_CALL UVERegisterInterestMT(CEZCLProcess* pCLProcess ,  long ID ) ;
EZ_DLL_CALL GetDeviceDetailsMT(CEZCLProcess* pCLProcess ,  long ID , long ZBID , PBSTR pSerialNo , PBSTR pBootVersion , PBSTR pFirmwareVersion ) ;
EZ_DLL_CALL SetZBCoordPanMT(CEZCLProcess* pCLProcess ,  long ID , __int64 Pan ) ;
EZ_DLL_CALL GetZBCoordPanMT(CEZCLProcess* pCLProcess ,  long ID ) ;
EZ_DLL_CALL ReadUVEMT(CEZCLProcess* pCLProcess ,  long ID , long ZBID , short Antenna ) ; 
EZ_DLL_CALL SetHoseETotalsMT(CEZCLProcess* pCLProcess ,  long ID , double Volume , double Value ) ;
EZ_DLL_CALL GetNextZBStatusEventMT(CEZCLProcess* pCLProcess , long* pPortID , long* pZBID , __int64* pZBAddress, short* pCondition , short* pCount , short* pStrength ) ;
EZ_DLL_CALL GetNextZBPanIDEventMT(CEZCLProcess* pCLProcess , long* pPortID , __int64* pZBPanID ) ;
EZ_DLL_CALL GetNextZeroDeliveryEventMT(CEZCLProcess* pCLProcess ,  long* pPumpID , long* pPumpNumber , long* pHoseID , long* pHoseNumber ) ;
EZ_DLL_CALL SetIOPinMT(CEZCLProcess* pCLProcess ,  long ID , long ZBID , short Slot , short IOPin , short Value ) ;
EZ_DLL_CALL SetHosePricesMT(CEZCLProcess* pCLProcess ,  long ID , short DurationType , short PriceType , double Price1 , double Price2 ) ;
EZ_DLL_CALL SetPumpDefaultPriceLevelMT(CEZCLProcess* pCLProcess ,  long ID , short Level ) ;
EZ_DLL_CALL SetDateTimeMT( CEZCLProcess* pCLProcess , DATE DateTime ) ;
EZ_DLL_CALL GetNextZBCmdEventMT(CEZCLProcess* pCLProcess , long* pPortID , long* pZBID , __int64* pZBAddress, PBSTR pRxMsg ) ;
EZ_DLL_CALL GetNextZBRawEventMT(CEZCLProcess* pCLProcess , long* pPortID , long* pZBID , __int64* pZBAddress, PBSTR pRxMsg ) ;
EZ_DLL_CALL ZBSendRawMT(CEZCLProcess* pCLProcess ,  long ID , long ZBID , __int64 ZBAddress , BSTR TxMsg ) ;
EZ_DLL_CALL ZBSendCmdMT(CEZCLProcess* pCLProcess ,long ID , long ZBID , __int64 ZBAddress , BSTR TxMsg ) ;
EZ_DLL_CALL ZBCmdRegisterInterestMT(CEZCLProcess* pCLProcess , long ID , long ZBID ) ;
EZ_DLL_CALL ZBRawRegisterInterestMT(CEZCLProcess* pCLProcess , long ID , long ZBID ) ;




