#include <stdio.h>
#include <time.h>
#include <wchar.h>
#include <unistd.h>

#include "EZClient.h" 
#include "Definitions.h" 

PBSTR MakeBSTR( wchar_t* pStr , int Len ) 
{
	for ( int i = 0 ; i+1 < Len ; pStr[i++] = ' ' ) ;
	pStr[ Len - 1 ] = 0 ;
	return ( PBSTR ) pStr ; 
}

int main()
{
    wchar_t temp[100] ;
	LONG Count = 0 ; 
	SHORT EventType ;
	LONG ClientID = 5 ; 


    LONG res = DllVersion( MakeBSTR( temp , sizeof( temp ) / sizeof( wchar_t ) ) ) ;
    printf( "res = %ld .SO version = %S.\n" , res , temp  ) ;

	res = ClientLogonEx( ClientID , 1 , ( PBSTR ) L"EZServerCE" , 5123 , 5124 , 10000 , NULL ,  NULL , NULL ) ;
	printf( "ClientLogonEx res = %ld\n" ,  res ) ;

	if ( res != 0 ) return -1 ;

	res = GetGradesCount( & Count ) ; 
	printf( "GetGradesCount res = %ld count = %ld.\n" , res , Count ) ;

	for ( long i = 1 ; i <= Count ; i++ ) 
	{
		long ID ; 
		long Number ; 
		wchar_t Name[ 31 ] ; 
		wchar_t ShortName[ 31 ] ; 
		wchar_t Code[ 31 ] ; 

		res = GetGradeByOrdinal( i , & ID ) ;
		res = GetGradeProperties( ID , & Number , 
								MakeBSTR( Name  , sizeof( Name ) / sizeof( wchar_t ) ) , 
								MakeBSTR( ShortName  , sizeof( ShortName ) / sizeof( wchar_t ) ) , 
								MakeBSTR( Code  , sizeof( Code ) / sizeof( wchar_t ) ) ) ;

		printf( "Grade %ld, %S.\n" , Number  , Name ) ;
	}
	res = GetTanksCount( & Count ) ; 
	printf( "GetTanksCount res = %ld count = %ld.\n" , res , Count ) ;
	for ( long i = 1 ; i <= Count ; i++ ) 
	{
		long ID ; 
		long Number ; 
		wchar_t Name[ 30 ] ; 
		long GradeID ;
		short Type ; 
		double Capacity ;
		double Diameter ; 
		double TheoVolume ;
		double GaugeVolume ;
		double GaugeTCVolume ;
		double GaugeUllage ; 
		double GaugeTemperature ; 
		double GaugeLevel ;
		double GaugeWaterVolume ; 
		double GaugeWaterLevel ;
		long GaugeID ; 
		short ProbeNo ;

		 ;

		res = GetTankByOrdinal( i , & ID ) ;
		res = GetTankProperties( ID , & Number , 
								MakeBSTR( Name  , sizeof( Name ) / sizeof( wchar_t ) ) , 
								& GradeID , & Type , & Capacity , & Diameter , 
							  & TheoVolume , & GaugeVolume , & GaugeTCVolume, & GaugeUllage, & GaugeTemperature , 
							  & GaugeLevel , & GaugeWaterVolume, & GaugeWaterLevel, & GaugeID, & ProbeNo ) ;
		printf( "Tank %ld, %S.\n" , Number  , Name ) ;
	}

	res = GetPumpsCount( & Count ) ; 
	printf( "GetPumpsCount res = %ld count = %ld.\n" , res , Count ) ;
	for ( long i = 1 ; i <= Count ; i++ ) 
	{
		long ID ; 
		long Number ; 
		wchar_t Name[ 30 ] ; 
		short PhysicalNumber; 
		short Side; 
		short Address; 
		short PriceLevel1;
		short PriceLevel2; 
		short PriceDspFormat; 
		short VolumeDspFormat; 
		short ValueDspFormat; 
		short Type; 
		long PortID; 
		long AttendantID; 
		short AuthMode;
		short StackMode; 
		short PrepayAllowed; 
		short PreauthAllowed ;
		long SlotZigBeeID; 
		long MuxSlotZigBeeID; 
		short PriceControl; 
		short HasPreset;

		res = GetPumpByOrdinal( i , & ID ) ;
		res = GetPumpPropertiesEx( ID , & Number , 
								   MakeBSTR( Name  , sizeof( Name ) / sizeof( wchar_t ) ) , 
								   &PhysicalNumber, &Side, &Address, &PriceLevel1,
								&PriceLevel2, &PriceDspFormat, &VolumeDspFormat, &ValueDspFormat, &Type, 
								&PortID, &AttendantID, &AuthMode, &StackMode, &PrepayAllowed, &PreauthAllowed ,
								&SlotZigBeeID , &MuxSlotZigBeeID , &PriceControl , &HasPreset ) ;
		printf( "Pump %ld, %S.\n" , Number  , Name ) ;
	}

	res = GetDeliveriesCount( & Count ) ; 
	printf( "GetDeliveriesCount res = %ld count = %ld.\n" , res , Count ) ;
	for ( long Ordinal = Count ; Ordinal > 0 ; Ordinal-- ) 
	{
		long DeliveryID = NULL_ID ;
		long HoseID = NULL_ID  ;
		short PriceLevel = 0  ; 
		double Price = 0  ; 
		double Volume = 0  ; 
		double Volume2 = 0  ; 
		double Value = 0  ; 
		short DeliveryState = 0  ; 
		short DeliveryType = 0  ;
		long LockedBy = NULL_ID  ; 
		long ReservedBy = NULL_ID  ; 
		long AttendantID = NULL_ID  ; 
		long Age = 0 ; 
		DATE CompletedDT ; 
		DATE ClearedDT ; 
		double OldVolumeETot = 0 ;
		double OldVolume2ETot = 0 ; 
		double OldValueETot = 0 ; 
		double NewVolumeETot = 0 ;
		double NewVolume2ETot = 0 ; 
		double NewValueETot = 0 ; 
		__int64 Tag = 0 ;
		long Duration = 0 ; 

		res = GetDeliveryByOrdinal( Ordinal , & DeliveryID ) ;
		res = GetDeliveryPropertiesEx2( DeliveryID , & HoseID, & DeliveryState , 
								     & DeliveryType, & Volume, & PriceLevel, & Price, 
									 & Value, & Volume2 , & CompletedDT ,  & LockedBy, & ReservedBy, 
									 & AttendantID, & Age , & ClearedDT , 
									 & OldVolumeETot , & OldVolume2ETot , & OldValueETot , 
									 & NewVolumeETot , & NewVolume2ETot , & NewValueETot , 
									 & Tag , & Duration  ) ;

		if ( DeliveryState == CURRENT || DeliveryState == STACKED )
		{
			// it is already locked by me !!
			if (  LockedBy == ClientID  )
			{
				res = ClearDelivery( DeliveryID , DeliveryType) ;
				LockedBy = ClientID ;
				printf( "Delivery %ld, on hose %ld cleared.\n" , DeliveryID  , HoseID ) ;
			}

			// if this delivery is locked by us but not cleared yet then clear it 
			else if ( LockedBy == -1 ) 
			{
				// process the delivery here 
				// save in local data base, when successful, LockAndClear to remove from EZF+
				LockAndClearDelivery( DeliveryID , DeliveryType ) ; 
				printf( "Delivery %ld, on hose %ld cleared.\n" , DeliveryID  , HoseID ) ;
			}
		}
	}

	return 0 ;

	for (int i = 0 ; i < 10 ; i++ ) 
	{

		// test our connection with the server, if lost logoff and logon again 
		if ( TestConnection() != OK_RESULT ) 
		{
			ClientLogoff() ;
			while ( ClientLogonEx( ClientID , 7 , ( BSTR ) L"10.1.0.155" , 5123 , 5124 , 10000 , NULL ,  NULL , NULL ) != OK_RESULT ) 
				Sleep( 5000 ) ;
		}

		res = ProcessEvents() ;
		res = GetEventsCount(  & Count ) ;

		bool HaveEvents = true ;
		while ( HaveEvents )  
		{
			res = GetNextEventType( & EventType ) ;

			switch ( EventType ) 
			{
				case NO_CLIENT_EVENT :
					HaveEvents = false ;
					break ;

				case PUMP_EVENT :
					{
						long PumpID = NULL_ID ; 
						short PumpNumber = 0 ;  
						short State = 0  ;  
						short ReservedFor = 0  ;  
						long ReservedBy  = NULL_ID;  
						long HoseID  = NULL_ID; 
						short HoseNumber = 0  ; 
						long GradeID  = NULL_ID;  
						wchar_t GradeName[ 100 ]  ;  
						wchar_t ShortGradeName[ 100 ] ; 
						short PriceLevel = 0  ;  
						double Price = 0  ;  
						double Volume = 0  ;  
						double Value = 0  ;  
						short StackSize = 0  ;  
						wchar_t PumpName[ 100 ] ;  
						short PhysicalNumber = 0  ;  
						short Side = 0  ; 
						short Address = 0  ;  
						short PriceLevel1 = 0  ;  
						short PriceLevel2 = 0  ;  
						short Type = 0  ;  
						long PortID  = NULL_ID ;  
						short AuthMode = 0  ;  
						short StackMode = 0  ;   
						short PrepayAllowed = 0  ;  
						short PreauthAllowed = 0  ;   
						short PriceFormat = 0  ;  
						short ValueFormat = 0  ;  
						short VolumeFormat = 0  ; 

						res = GetNextPumpEventEx( &PumpID, &PumpNumber, &State, &ReservedFor, &ReservedBy, &HoseID ,
												  &HoseNumber,&GradeID, 
												  MakeBSTR( GradeName , sizeof( GradeName ) / sizeof( wchar_t ) ) , 
												  MakeBSTR( ShortGradeName , sizeof( ShortGradeName ) / sizeof( wchar_t ) ) , &PriceLevel , &Price, &Volume, 
												  &Value, &StackSize, 
												  MakeBSTR( PumpName , sizeof( PumpName ) / sizeof( wchar_t ) ) , &PhysicalNumber , &Side , &Address, 
												  &PriceLevel1 , &PriceLevel2 , &Type , &PortID , &AuthMode , &StackMode ,  &PrepayAllowed, 
												  &PreauthAllowed ,  &PriceFormat , &ValueFormat , &VolumeFormat  ) ;

						printf( "Pump [%02d] event state %d\n" , PumpNumber , State ) ; 
					}
					break ;

				case DELIVERY_EVENT :
					{

						long DeliveryID = NULL_ID ;
						long PumpID = NULL_ID  ;
						short PumpNumber = 0  ;
						long HoseID = NULL_ID  ;
						short HoseNumber = 0  ; 
						long GradeID = NULL_ID  ; 
						wchar_t GradeName[ 100 ]  ;  
						wchar_t ShortGradeName[ 100 ] ; 
						short PriceLevel = 0  ; 
						double Price = 0  ; 
						double Volume = 0  ; 
						double Value = 0  ; 
						short DeliveryState = 0  ; 
						short DeliveryType = 0  ;
						long LockedBy = NULL_ID  ; 
						long ReservedBy = NULL_ID  ; 
						long Age = 0 ; 
						DATE CompletedDT ; 
						long AttendantID = NULL_ID  ; 
						double OldVolumeETot = 0 ;
						double OldVolume2ETot = 0 ; 
						double OldValueETot = 0 ; 
						double NewVolumeETot = 0 ;
						double NewVolume2ETot = 0 ; 
						double NewValueETot = 0 ; 
						__int64 Tag = 0 ;
						long Duration = 0 ; 

						res = GetNextDeliveryEventEx2( & DeliveryID , & PumpID, & PumpNumber, & HoseID, & HoseNumber , 
								     & GradeID, MakeBSTR( GradeName , sizeof( GradeName ) / sizeof( wchar_t ) ) ,
									 MakeBSTR( ShortGradeName , sizeof( ShortGradeName ) / sizeof( wchar_t ) ) , 
									 & PriceLevel, & Price, 
									 & Volume, & Value, & DeliveryState , 
								     & DeliveryType, & LockedBy, & ReservedBy, & Age , & CompletedDT , 
									 & AttendantID, 
									 & OldVolumeETot , & OldVolume2ETot , & OldValueETot , 
									 & NewVolumeETot , & NewVolume2ETot , & NewValueETot , 
									 & Tag , & Duration ) ;

						if ( DeliveryID != ( long ) NULL_ID ) 
						{
							printf( "Delivery %d event\n" , ( int ) DeliveryID ) ; 

							// if this delivery is still available lock it 
							if ( LockedBy == ( long ) NULL_ID )
							{
								res = LockDelivery( DeliveryID ) ;
								LockedBy = ClientID ;
							}

							// if this delivery is locked by us but not cleared yet then clear it 
							if ( LockedBy == ClientID && ( DeliveryState == CURRENT || DeliveryState == STACKED ) ) 
							{
								// process the delivery here 
								ClearDelivery( DeliveryID , DeliveryType ) ; 
							}
						}
					}
					break ;

				default :
					res = DiscardNextEvent() ;
					break ;
			}
		}
	}

	ClientLogoff() ;


   return 0;
}
